/*-----------------------------------------------------------------------------
	ClockPod / IAccessible ɂeLXg擾						(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include "CLOCKPOD.H"
#include "WINOLE.H"

HMODULE hOLEACC = NULL;
HMODULE hOleaut32 = NULL;

DefineWinAPI(HRESULT, AccessibleObjectFromPoint, (POINT, IAccessible **, VARIANT *) )= NULL;

DefineWinAPI(void, VariantInit, (_Outptr_ VARIANTARG *));
DefineWinAPI(HRESULT, VariantClear, (_Inout_ VARIANTARG *));
DefineWinAPI(void, SysFreeString, (BSTR));

typedef HRESULT (STDMETHODCALLTYPE IAccessible::* MTH_IAccGetStr)(VARIANT, BSTR *);

BOOL GetAccPropText(IAccessible *pAcc, const VARIANT &varChild,
		WCHAR *str, DWORD size, BOOL UseInvoke, MTH_IAccGetStr pGetStrProp,
		DISPID DispID)
{
	HRESULT hr;
	BSTR gettext = NULL;
	BOOL result;

	if ( UseInvoke == FALSE ){
		hr = (pAcc->*pGetStrProp)(varChild, &gettext);
	}else{
		DISPPARAMS dispp;
		EXCEPINFO excepInfo;
		UINT errArg;
		VARIANT varResult;
		VARIANT varArg = varChild;

		DVariantInit( &varResult );

		dispp.cArgs = 1;
		dispp.cNamedArgs = 0;
		dispp.rgvarg = &varArg;
		dispp.rgdispidNamedArgs = NULL;

		memset(&excepInfo, 0, sizeof(excepInfo));

		hr = pAcc->Invoke(DispID, IID_NULL, 0, DISPATCH_PROPERTYGET,
				&dispp, &varResult, &excepInfo, &errArg);
		if ( SUCCEEDED(hr) && (varResult.vt == VT_BSTR) ){
			gettext = varResult.bstrVal;
		}else{
			DVariantClear(&varResult);
		}
	}
	if ( hr == S_OK ){
		if ( gettext != NULL ){
			DWORD csize;

			csize = (DWORD)wcslen(gettext);
			if ( csize >= size ) csize = size - 1;
			memcpy(str, gettext, TSTROFF(csize));
			str[csize] = '\0';
			DSysFreeString(gettext);
			result = TRUE;
		}else{
			result = FALSE;
		}
	}else{
		result = FALSE;
	}
	return result;
}

void GetStringFromPoint(POINT *pos, WCHAR *name, WCHAR *value, DWORD size)
{
	IAccessible *pAcc = NULL;
	VARIANT varChild;

	name[0] = '\0';
	value[0] = '\0';

	if ( hOLEACC == NULL ){
		hOLEACC = LoadLibraryA("OLEACC.DLL");
		if ( hOLEACC == NULL ){
			hOLEACC = (HMODULE)INVALID_HANDLE_VALUE;
		}else{
			GETDLLPROC(hOLEACC, AccessibleObjectFromPoint);

			hOleaut32 = LoadLibraryA("Oleaut32.DLL");
			GETDLLPROC(hOleaut32, VariantInit);
			GETDLLPROC(hOleaut32, VariantClear);
			GETDLLPROC(hOleaut32, SysFreeString);
		}
	}

	if ( DAccessibleObjectFromPoint == NULL ) return;

	DVariantInit(&varChild);
	HRESULT hr = DAccessibleObjectFromPoint(*pos, &pAcc, &varChild);
	if ( FAILED(hr) ) return;

	GetAccPropText(pAcc, varChild, name, size, FALSE, &IAccessible::get_accName, DISPID_ACC_NAME );
	GetAccPropText(pAcc, varChild, value, size, FALSE, &IAccessible::get_accValue, DISPID_ACC_VALUE );
	DVariantClear(&varChild);
	pAcc->Release();
}
