/*-----------------------------------------------------------------------------
	ClockPod / 擾͓̉										(c)TORO
-----------------------------------------------------------------------------*/
#define USEGPUNV 0
#define USEGPUATI 1

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <dbt.h>
#include "CLOCKPOD.H"
#include "HWINFS.H"
#include "CLK_MSTR.C"

#if USEGPUNV
	#include "nvapi.h"
#endif
#if USEGPUATI
	#define DefineCAPI(retvar, name, param) typedef retvar (USECDECL *imp ## name) param; imp ## name D ## name

	#define ADL_OK 0
	#define ADL_ERR -1
	typedef void * (__stdcall *ADL_MAIN_MALLOC_CALLBACK)(int);
	typedef struct {
		int iSize;
		int iEngineClock;
		int iMemoryClock;
		int iVddc;
		int iActivityPercent;
		int iCurrentPerformanceLevel;
		int iCurrentBusSpeed;
		int iCurrentBusLanes;
		int iMaximumBusLanes;
		int iReserved;
	} ADLPMActivity;

	typedef struct {
		int iSize;
		int iTemperature;
	} ADLTemperature;

	DefineCAPI(int, ADL_Main_Control_Create, (ADL_MAIN_MALLOC_CALLBACK, int));
	DefineCAPI(int, ADL_Main_Control_Destroy, (void));
	DefineCAPI(int, ADL_Adapter_Active_Get, (int, int *));
	DefineCAPI(int, ADL_Overdrive5_CurrentActivity_Get, (int, ADLPMActivity *));
	DefineCAPI(int, ADL_Overdrive5_Temperature_Get, (int, int, ADLTemperature *));

	void * __stdcall ADL_Main_Memory_Alloc(int iSize)
	{
		void *lpBuffer = malloc(iSize);
		return lpBuffer;
	}

	void __stdcall ADL_Main_Memory_Free(void **lpBuffer)
	{
		if ( NULL == *lpBuffer ) return;
		free(*lpBuffer);
		*lpBuffer = NULL;
	}
#endif
#pragma hdrstop

int OldHWINFS = 0;

//==================================================================== d
static DWORD ReadBatteryTick;
void BatteryCheckMain(void)
{
	if ( DGetSystemPowerStatus == NULL ) return;
	if ( DGetSystemPowerStatus(&PowStatus) == FALSE ) return;
	ReadBatteryTick = GetTickCount();
	if ( PowStatus.BatteryFlag == 0xff ) return;
							// Battery = Low/Critical
	Z_ExecAction( (PowStatus.BatteryFlag & (B1 | B2)) ?
			zPowerLow : zPowerBroad, NULL);
}
void ReadBatteryInfo(void)
{
	DWORD tick;

	tick = GetTickCount();
	if ( (tick - ReadBatteryTick) >= 5*3600 ){
		ReadBatteryTick = tick;
		BatteryCheckMain();
	}
}
//================================================================ foCX
struct DEVICECHANGESTRUCT{
	UINT event;
	TCHAR *name;
	int param;		// 0:None 1:DEV_BROADCAST_HDR 2:DEV_BROADCAST_USERDEFINED
					// 3:xy	4:CONFIGMG 5:VolLockBtoadcast 6:Drive
};
static const struct DEVICECHANGESTRUCT Event[] = {
	{DBT_APPYBEGIN,				T("APPYBEGIN"),				0},	//0x0000
	{DBT_APPYEND,				T("APPYEND"),				0},	//0x0001
	{DBT_DEVNODES_CHANGED,		T("Devnodes changed"),		0},	//0x0007
	{DBT_QUERYCHANGECONFIG,		T("QueryChangeConfig"),		0},	//0x0017
	{DBT_CONFIGCHANGED,			T("ConfigChanged"),			0},	//0x0018
	{DBT_CONFIGCHANGECANCELED,	T("ConfigChangeCanceled"),	0},	//0x0019
	{DBT_MONITORCHANGE,			T("MonitorChange"),			3},	//0x001b
	{DBT_SHELLLOGGEDON,			T("Shell logon"),			0},	//0x0020
	{DBT_CONFIGMGAPI32,			T("CONFIGMG api32"),		4},	//0x0022
	{DBT_VXDINITCOMPLETE,		T("CONFIGMG vxd"),			0},	//0x0023
	{DBT_VOLLOCKQUERYLOCK,		T("VolLockQueryLock"),		5},	//0x8041
	{DBT_VOLLOCKLOCKTAKEN,		T("VolLockLockTaken"),		5},	//0x8042
	{DBT_VOLLOCKLOCKFAILED,		T("VolLockLockFailed"),		5},	//0x8043
	{DBT_VOLLOCKQUERYUNLOCK,	T("VolLockQueryUnlock"),	5},	//0x8044
	{DBT_VOLLOCKLOCKRELEASED,	T("VolLockLockReleased"),	5},	//0x8045
	{DBT_VOLLOCKUNLOCKFAILED,	T("VolLockUnlockFailed"),	5},	//0x8046
	{DBT_NO_DISK_SPACE,			T("No disk space"),			6},	//0x0047
	{DBT_LOW_DISK_SPACE,		T("Low disk space"),		6},	//0x0048
	{DBT_CONFIGMGPRIVATE,		T("CONFIGMG private"),		0},	//0x7fff
	{DBT_DEVICEARRIVAL,			T("Detected a new device"),	1},	//0x8000
	{DBT_DEVICEQUERYREMOVE,		T("Wants to remove, may fail"),	1},	//0x8001
	{DBT_DEVICEQUERYREMOVEFAILED, T("Removal aborted"),		1},	//0x8002
	{DBT_DEVICEREMOVEPENDING,	T("About to remove"),		1},	//0x8003
	{DBT_DEVICEREMOVECOMPLETE,	T("Device is gone"),		1},	//0x8004
	{DBT_DEVICETYPESPECIFIC,	T("Type specific event"),	1},	//0x8005
	{DBT_CUSTOMEVENT,			T("Custom event"),			1},	//0x8006
	{DBT_USERDEFINED,			T("User event"),			2},	//0xffff
	{0xffffffff,				T("Unknown"),				0}};

#ifdef UNICODE
	#define strlimcpyAtoT(dest, src, size) AnsiToUnicode(src, dest, size)
#else
	#define strlimcpyAtoT(dest, src, size) tstrlimcpy(src, dest, size)
#endif

//-------------------------------------WM_DEVICECHANGE ̉͏
void DevChange(WPARAM wParam, LPARAM lParam)
{
	const struct DEVICECHANGESTRUCT *event;
	TCHAR mbuf[0x200];
	TCHAR more[0x200];
	int type = zDeviceInfo;

	if ( ((UINT)wParam == DBT_DEVNODES_CHANGED) && X_devnodes ) return;

	event = Event;
	while ( event->event != 0xffffffff ){
		if ( event->event == (UINT)wParam ) break;
		event++;
	}
	more[0] = 0;
	switch(event->param){
		case 1:{	// DEV_BROADCAST_HDR --------------------------------------
			switch ( ((PDEV_BROADCAST_HDR)lParam)->dbch_devicetype ){
				case DBT_DEVTYP_DEVICEINTERFACE:
					tstrlimcpy(more,
						((PDEV_BROADCAST_DEVICEINTERFACE)lParam)->dbcc_name,
						TSIZEOF(more) - 1);
					more[TSIZEOF(more) -1] = '\0';
					{
						TCHAR *p;

						p = tstrchr(more, '{');
						if ( p != NULL ) *p = '\0';
					}
					break;
				case DBT_DEVTYP_HANDLE:
					tstrcpy(more, T("HANDLE"));
					break;
				case DBT_DEVTYP_OEM:
					tstrcpy(more, T("OEM"));
					break;
				case DBT_DEVTYP_PORT:
					tstrlimcpy(more,
							((PDEV_BROADCAST_PORT)lParam)->dbcp_name,
							TSIZEOF(more) - 1);
					more[TSIZEOF(more) -1] = '\0';
					break;
				case DBT_DEVTYP_VOLUME: {
					int i, f;

					f = ((PDEV_BROADCAST_VOLUME)lParam)->dbcv_unitmask;
					for ( i = 0 ; i < 26 ; i++ ){
						if ( f & (B0 << i) ) break;
					}
					wsprintf(more, T("%c"), i + 'A');
					f = ((PDEV_BROADCAST_VOLUME)lParam)->dbcv_flags;
					if ( f & DBTF_MEDIA ) tstrcat(more, T("(media)"));
					if ( f & DBTF_NET ) tstrcat(more, T("(net)"));
					type = zDriveChg;
					break;
				}
				default:
					tstrcpy(more, T("Unknown"));
			}
			break;
		}

		case 2:	// DEV_BROADCAST_USERDEFINED ------------------------------
			strlimcpyAtoT(more,
					((struct _DEV_BROADCAST_USERDEFINED *)lParam)->dbud_szName,
					TSIZEOF(more) - 1);
			more[TSIZEOF(more) - 1] = '\0';
			break;

		case 3:		// xy -----------------------------------------------------
			wsprintf(more, T("X:%d Y:%d"), LOWORD(lParam), HIWORD(lParam));
			break;

		case 6:		// drive --------------------------------------------------
			wsprintf(more, T("%c"), lParam + '@');
			type = zDriveChg;
			break;

		default:
			type = zDeviceChg;
	}
	wsprintf(mbuf, T("1%s\t2%s"), event->name, more);
	Z_ExecAction(type, mbuf);
}
//==================================================================== RAS 
//------------------------------------- o^ĂȂڑo^
BOOL AddConnection(TCHAR *pcname, TCHAR *rasname)
{
	int i, nouse = MAXRAS;
	TCHAR buf[300];

	for ( i = 0 ; i < MAXRAS ; i++ ){
		if ( !ConnectionList[i].rasname[0] ){
			if ( nouse > i ) nouse = i;
			continue;
		}
		if ( tstrcmp(ConnectionList[i].pcname, pcname) ) continue;
		if ( tstrcmp(ConnectionList[i].rasname, rasname) ) continue;
		resetflag(ConnectionList[i].flag, CLF_CHECK);
		nouse = MAXRAS;
		break;
	}
	if ( nouse < MAXRAS ){
		LastConnection = nouse;
		tstrcpy(ConnectionList[nouse].pcname, pcname);
		tstrcpy(ConnectionList[nouse].rasname, rasname);
		ConnectionList[nouse].lap = TimerNowTick;
		ConnectionList[nouse].time = TimerNowTick;
		ConnectionList[nouse].flag = 0;

		wsprintf(buf, T("1%s\t2%s"), rasname, pcname);
		StartMailCheck(B4, -1);
		Z_ExecAction(zRasConnect, buf);
		return TRUE;
	}else{
		return FALSE;
	}
}
//------------------------------------- o^ĂȂؒfo^
void DelConnection(TCHAR *pcname, TCHAR *rasname)
{
	int i;
	TCHAR buf[300];

	for ( i = 0 ; i < MAXRAS ; i++ ){
		if ( !ConnectionList[i].rasname[0] ) continue;
		if ( tstrcmp(ConnectionList[i].pcname, pcname) ) continue;
		if ( tstrcmp(ConnectionList[i].rasname, rasname) ) continue;
		wsprintf(buf, T("1%s\t2%s\t3%d"),
				rasname, pcname,
				GetPassSec(ConnectionList[i].time) );

		ConnectionList[i].pcname[0] = 0;
		ConnectionList[i].rasname[0] = 0;

		Z_ExecAction(zRasDConnect, buf);
		break;
	}
}
//------------------------------------- ":name/name>"  pcname/rasname o
BOOL Rasnames(TCHAR *src, TCHAR *pcname, TCHAR *rasname)
{
	TCHAR *p;

	p = src + tstrlen(src) - 1;
	if ( *p != '>' ) return FALSE;
	*p = '\0';
	p = tstrchr(src, '/');
	if ( p != NULL ){
		tstrcpy(pcname, p + 1);
		*p = '\0';
	}else{
		tstrcpy(pcname, T("Unknown"));
	}
	tstrcpy(rasname, src);
	return TRUE;
}
//------------------------------------- RAS擾
void RasCheckMain(void)
{
	RASCONN Rasconn[MAXRAS];
	DWORD vsize, connections;

	if ( X_raslap ){
		int i;
		for ( i = 0; i < MAXRAS; i++ ){
			if ( !ConnectionList[i].rasname[0] ) continue;	// o^
											// RAS ڑԂɂC^[o
			if ( GetPassSec(ConnectionList[i].lap) >= (DWORD)X_raslap ){
				TCHAR buf[0x100];

				ConnectionList[i].lap = TimerNowTick;
				wsprintf(buf, T("1%s\t2%s\t3%d"),
						 ConnectionList[i].rasname,
						 ConnectionList[i].pcname,
						 GetPassSec(ConnectionList[i].time));
				Z_ExecAction(zRasLap, buf);
			}
		}
	}
	if ( hRASAPI32 == NULL ) return;
										// 񌟏op̃tOݒ
	{
		int i;
		for ( i = 0; i < MAXRAS; i++ ){
			setflag(ConnectionList[i].flag, CLF_CHECK);
		}
	}
	vsize = sizeof(Rasconn);
	Rasconn[0].dwSize = sizeof(RASCONN);

	if ( DRasEnumConnections((LPRASCONN)&Rasconn, &vsize, &connections) ){
		Z_ExecAction(zError, T("1RAS"));
	}else{
		DWORD i;

		for ( i = 0 ; i < connections ; i++ ){
			RASCONNSTATUS rasstatus;

			rasstatus.dwSize = sizeof(rasstatus);
			if (! DRasGetConnectStatus(Rasconn[i].hrasconn, &rasstatus) ){
				if ( rasstatus.rasconnstate == RASCS_Connected ){
					if ( AddConnection(PCname, Rasconn[i].szEntryName) &&
								(X_ras > 1)){
						TCHAR buf[MESLEN];

						wsprintf(buf, T("<Connect:%s/%s>"),
								Rasconn[i].szEntryName, PCname);
						SendPodSlot(T("*"), buf);
					}
				}
			}
		}
										// (ؒf)o
		for ( i = 0 ; i < MAXRAS ; i++ ){
			if ( !ConnectionList[i].rasname[0] ) continue;	// o^
			if ( !(ConnectionList[i].flag & CLF_CHECK) ) continue; // ڑmF
			if ( tstrcmp(ConnectionList[i].pcname, PCname) ) continue; // PC
			if ( X_ras > 1 ){
				TCHAR buf[MESLEN];

				wsprintf(buf, T("<Disconnect:%s/%s>"),
								ConnectionList[i].rasname, PCname);
				SendPodSlot(T("*"), buf);
			}
			DelConnection(PCname, ConnectionList[i].rasname);
			break;
		}
	}
}

//==================================================================== IME 
const TCHAR IMEstatusstringD[] = T("`A");
const TCHAR IMEstatusstringS[] = T("A A?? ");

void GetIMEinfo(DWORD param)
{
	static DWORD OldIMEStatus = IME_OFF;

	if ( (param == OldIMEStatus) && !(param & IME_CAPTIONCHANGE) ) return;

	OldIMEStatus = param & ~IME_CAPTIONCHANGE;

	if ( param == IME_DIABLE ){
		tstrcpy(IMEstatus, T(" off"));
	}else if ( param == IME_OFF ){
		tstrcpy(IMEstatus, T(" off"));
	}else{
		const TCHAR *p;

		tstrcpy(IMEstatus, T("    "));

		if ( param & IME_CMODE_NOCONVERSION ){
			IMEstatus[0] = 'n';
		}
		if ( param & IME_CMODE_ROMAN ){
			IMEstatus[1] = 'R';
		}
		if ( param & IME_CMODE_CHARCODE ){
			IMEstatus[1] = 'C';
		}
		#ifdef UNICODE
			if ( param & IME_CMODE_FULLSHAPE ){
				IMEstatus[2] = IMEstatusstringD[param & 3];
				IMEstatus[3] = '\0';
			}else{
				p = IMEstatusstringS + (param & 3) * 2;
				IMEstatus[2] = *(p + 0);
				IMEstatus[3] = *(p + 1);
			}
		#else
			p = ((param & IME_CMODE_FULLSHAPE) ?
					IMEstatusstringD : IMEstatusstringS) + (param & 3) * 2;
			IMEstatus[2] = *(p + 0);
			IMEstatus[3] = *(p + 1);
		#endif
	}
	Z_ExecAction(zIME, NULL);
	SetTime();
}

//=============================================================== CPUgp
int GetCPUusing9xSub(TCHAR *keyname)
{
	HKEY HK;
	LONG result;
	DWORD s;
	BYTE val[4];

	if ( RegOpenKeyEx(HKEY_DYN_DATA, keyname, 0, KEY_QUERY_VALUE, &HK)
			!= ERROR_SUCCESS){
		return -1;
	}
	s = sizeof(val);
	result = RegQueryValueEx(HK, T("KERNEL\\CPUUsage"), NULL, NULL, val, &s);
	RegCloseKey(HK);
	if (result != ERROR_SUCCESS) return -1;
	return val[0];
}

int GetCPUusing9x(void)
{
	static BOOL usecpu = 0;

	if ( !usecpu ){	// ptH[}XJE^̗pJnʒm
		usecpu = 1;
		GetCPUusing9xSub(T("PerfStats\\StartStat"));
		// pIƂ́AGetCPUusing9xSub("PerfStats\\StopStat"); 
	}
	return GetCPUusing9xSub(T("PerfStats\\StatData"));
}

//  456340ms(V) ȓɍēxĂяoKv
int GetCPUusingNT(void)
{
	static PERF_DATA_BLOCK *perfdata = NULL;
	static DWORD datasize = 0x2000;
	PERF_OBJECT_TYPE *pobj;
	DWORD i;
									// ptH[}Xf[^擾
	if ( perfdata == NULL ) perfdata = HeapAlloc(GetProcessHeap(), 0, datasize);
	if ( perfdata == NULL ) return -1;
	for(;;){
		LONG result;
		DWORD size;
		PERF_DATA_BLOCK * newperfdata;

		size = datasize;
		result = RegQueryValueEx(HKEY_PERFORMANCE_DATA, T("238"),
										NULL, NULL, (LPBYTE)perfdata, &size);
		if ( result == ERROR_SUCCESS) break;
		if ( result != ERROR_MORE_DATA) return -1;

		datasize += 0x400;
		newperfdata = HeapReAlloc(GetProcessHeap(), 0, perfdata, datasize);
		if ( newperfdata == NULL ){
			HeapFree(GetProcessHeap(), 0, perfdata);
			perfdata = NULL;
			return -1;
		}
		perfdata = newperfdata;
	}
									// 
	pobj = (PPERF_OBJECT_TYPE)((BYTE *)perfdata + perfdata->HeaderLength);
	for ( i = perfdata->NumObjectTypes ; i ; i-- ){
		if ( pobj->ObjectNameTitleIndex == 238 ){
			if ( pobj->NumInstances ){
				PERF_COUNTER_DEFINITION		*pcdef;
				PERF_COUNTER_BLOCK			*pcblock;
				PERF_INSTANCE_DEFINITION	*pfIdef;
				DWORD j;

				pcdef = (PERF_COUNTER_DEFINITION *)
						((BYTE *)pobj + pobj->HeaderLength);
				pfIdef = (PERF_INSTANCE_DEFINITION *)
						((BYTE *)pobj + pobj->DefinitionLength);
				for ( j = pobj->NumInstances - 1 ; j ; j-- ){
					pcblock = (PERF_COUNTER_BLOCK *)
							((BYTE *)pfIdef + pfIdef->ByteLength);
					pfIdef = (PERF_INSTANCE_DEFINITION *)
							((BYTE *)pcblock + pcblock->ByteLength);
				}

				pcblock = (PERF_COUNTER_BLOCK *)
						((BYTE *)pfIdef + pfIdef->ByteLength);
				for ( j = pobj->NumCounters ; j ; j-- ){
					if ( pcdef->CounterNameTitleIndex == 6 ){
						if ( pcdef->CounterSize == 8 ){
							static DWORD oldL, oldH, oldtime;
							DWORD dataL, dataH, newtime, *p, delta;

							newtime = GetTickCount();
							p = (DWORD *)
									((BYTE *)pcblock + pcdef->CounterOffset);
							dataL = *(p + 0);
							dataH = *(p + 1);
							SubDD(dataL, dataH, oldL, oldH);
							oldL = *(p + 0);
							oldH = *(p + 1);

							delta = newtime - oldtime;
							oldtime = newtime;
							if ( !delta ) return -1;
							if ( delta & 0x80000000 ) delta = 0 - delta;
							if ( dataH ) return 100; // overflow 
							return 100 - dataL / ( delta * 100);
						}
					}
					pcdef = (PERF_COUNTER_DEFINITION *)
							((BYTE *)pcdef + pcdef->ByteLength);
				}
			}
		}
		pobj = (PERF_OBJECT_TYPE *)((BYTE *)pobj + pobj->TotalByteLength);
	}
	return -1;
}

int GetCPUusing(void)
{
	if (OSver.dwPlatformId == VER_PLATFORM_WIN32_NT){
		return GetCPUusingNT();
	}else{
		return GetCPUusing9x();
	}
}
//================================================================= HDDx
char HDTEMPstr[64];
DWORD HDTEMPtick = 0;

DWORD GetHWINFSdata(char *sendstr, DWORD sendsize, char *recvstr, DWORD recvsize)
{
	DWORD getsize = 0;

	recvstr[0] = '\0';
	if ( CallNamedPipe( T(PipeName), sendstr, sendsize, recvstr,
			recvsize - 1, &getsize, PIPEWAITTIME) == FALSE ){
		SetLastError(ERROR_ACCESS_DENIED);
		return 0;
	}
	recvstr[getsize] = '\0';
	return getsize;
}

BOOL CallHDTEMP(TCHAR driveno, TCHAR *result)
{
	char pipebuf[PipeBuffers];
	DWORD tick;

	tick = GetTickCount();
	if ( (tick - HDTEMPtick) >= 10000 ){
		result[0] = '\0';
		HDTEMPtick = tick;
		if ( driveno <= '0' ) driveno = '1';
		pipebuf[0] = 'H';
		pipebuf[1] = 'T';
		pipebuf[2] = (char)driveno;
		pipebuf[3] = '\0';
		if ( GetHWINFSdata(pipebuf, 4, HDTEMPstr, sizeof(HDTEMPstr)) == FALSE ){
			strcpy(HDTEMPstr, "Error");
			return FALSE;
		}
	}
	strcpyAToT(result, HDTEMPstr, sizeof(HDTEMPstr));
	return TRUE;
}
/*============================================== Intel CPUx(Core2p)
	WinRing0.dll Έꉞ@\܂A̕ۏ؂܂B
	  R:WinRing0̃hCóAW[UANZX\łA
	  gɂĂ̓VXej󂪂ł邽߁B

	 UP0, UP1 łQ̃RACPUx\܂B
*/
DWORD CPUtick = 0;

#ifdef UNICODE
int USEFASTCALL GetNumberA(LPCSTR *ptr)
{
	char data;
	const char *p;
	int num = 0, minus = 0;

	p = *ptr;
	while ( *p == ' ' ) p++;
	if ( *p == '-' ){
		minus = 1;
		p++;
	}
	if ( Isdigit(*p) ){
		while( Isdigit( data = *p) ){
			p++;
			num = num * 10 + (data - '0');
		}
	}else{
		num = -1;
	}
	*ptr = p;
	if ( (num >= 0) && minus ) num = -num;
	return num;
}
#endif

void GetCPUTemp(void)
{
	DWORD tick;
	char pipebuf[PipeBuffers], result[PipeBuffers];
	const char *p;

	tick = GetTickCount();
	if ( (tick - CPUtick) < 10000 ) return;
	CPUtick = tick;

	pipebuf[0] = 'C';
	pipebuf[1] = 'T';
	pipebuf[2] = '1';
	pipebuf[3] = '\0';
	if ( GetHWINFSdata(pipebuf, 4, result, sizeof(result)) == FALSE ){
		return;
	}
	p = result;
	CPUtemp1 = GetNumberA(&p);

	pipebuf[2] = '2';
	if ( GetHWINFSdata(pipebuf, 4, result, sizeof(result)) == FALSE ){
		return;
	}
	p = result;
	CPUtemp2 = GetNumberA(&p);
}
//===================================================== CPUNbN
HANDLE hPOWERPROF = NULL;
DWORD CPUItick = 0;

enum POWER_INFORMATION_LEVEL {
	DSystemBatteryState = 5,
	DProcessorInformation = 11
};
#if (WINVER < 0x0500)
/*
typedef struct {
	BOOLEAN AcOnLine;
	BOOLEAN BatteryPresent;
	BOOLEAN Charging;
	BOOLEAN Discharging;
	BOOLEAN Spare1[4];
	DWORD MaxCapacity; // őe mWh
	DWORD RemainingCapacity; // c
	DWORD Rate; // dd
	DWORD EstimatedTime; // cb
	DWORD DefaultAlert1;
	DWORD DefaultAlert2;
} SYSTEM_BATTERY_STATE;
*/
#endif

DefineWinAPI(ULONG, CallNtPowerInformation, (enum POWER_INFORMATION_LEVEL InformationLevel, PVOID lpInputBuffer, ULONG nInputBufferSize, PVOID lpOutputBuffer, ULONG nOutputBufferSize));

SYSTEM_INFO sysinfo;

void GetCpuClock(void)
{
	DWORD tick;

	if ( hPOWERPROF == NULL ){
		sysinfo.dwNumberOfProcessors = 0;
		hPOWERPROF = LoadLibraryA("POWRPROF.DLL");
		if ( hPOWERPROF == NULL ) return;
		GETDLLPROC(hPOWERPROF, CallNtPowerInformation);
		GetSystemInfo(&sysinfo);
	}

	tick = GetTickCount();
	if ( (tick - CPUItick) < 10000 ) return;
	CPUItick = tick;

	if ( DCallNtPowerInformation(DProcessorInformation, NULL, 0, &cpuinfo[0], sizeof(cpuinfo)) == 0 ){
/*
		char buf[200], *p;
		DWORD i;

		p = buf;
		for ( i = 0 ; i < sysinfo.dwNumberOfProcessors ; i++ ){
			p += wsprintf(p, "CPU%d: %dMHz %d %d\n", i, cpuinfo[i].CurrentMhz, cpuinfo[i].MaxIdleState, cpuinfo[i].CurrentIdleState);
		}
		Message(buf);
*/
	}
}

#ifdef _WIN64
	#define MEMTYPE SIZE_T
	#define PREPAREDATA(mem, memex) (mem / (1024*1024))
#else
	#define MEMTYPE DWORD
	typedef struct {
		DWORD low, high;
	} D_DWORDLONG;
	typedef struct {
		DWORD dwLength;
		DWORD dwMemoryLoad;
		D_DWORDLONG ullTotalPhys;
		D_DWORDLONG ullAvailPhys;
		D_DWORDLONG ullTotalPageFile;
		D_DWORDLONG ullAvailPageFile;
		D_DWORDLONG ullTotalVirtual;
		D_DWORDLONG ullAvailVirtual;
		D_DWORDLONG ullAvailExtendedVirtual;
	} D_MEMORYSTATUSEX;

	DefineWinAPI(VOID, GlobalMemoryStatusEx, (D_MEMORYSTATUSEX *lpBuffer)) = INVALID_VALUE(impGlobalMemoryStatusEx);

	#define PREPAREDATA(mem, memex) GetMemSize(mem, &memex)

	MEMTYPE GetMemSize(MEMTYPE state, D_DWORDLONG *stateex)
	{
		if( DGlobalMemoryStatusEx == NULL ){
			return state / (1024*1024);
		}else{
			return (stateex->low / (1024*1024)) + (stateex->high * (4 * 1024));
		}
	}
	D_MEMORYSTATUSEX memstatex;
#endif
	MEMORYSTATUS memstat;
	DWORD MemTick;

void GetMemoryInfo(TCHAR type, TCHAR *destbuf)
{
	MEMTYPE data;
	DWORD tick;

	tick = GetTickCount();
	if ( (tick - MemTick) >= 500 ){
		MemTick = tick;

#ifndef _WIN64
		if ( DGlobalMemoryStatusEx == INVALID_VALUE(impGlobalMemoryStatusEx) ){
			GETDLLPROC(GetModuleHandleA("KERNEL32.DLL"), GlobalMemoryStatusEx);
		}
		if ( DGlobalMemoryStatusEx != NULL ){
			memstatex.dwLength = sizeof(memstatex);
			DGlobalMemoryStatusEx(&memstatex);
		}else{
			GlobalMemoryStatus(&memstat);
			memstat.dwLength = sizeof(memstat);
		}
#else
		memstat.dwLength = sizeof(memstat);
		GlobalMemoryStatus(&memstat);
#endif
	}
	switch(type){
		case 'R':
#ifdef _WIN64
			data = memstat.dwMemoryLoad;
#else
			data = (DGlobalMemoryStatusEx != NULL) ?
					memstatex.dwMemoryLoad : memstat.dwMemoryLoad;
#endif
			break;

		case 'T':
			data = PREPAREDATA(memstat.dwTotalPhys, memstatex.ullTotalPhys);
			break;
		case 't':
			data = PREPAREDATA(memstat.dwTotalPageFile, memstatex.ullTotalPageFile);
			break;

		case 'F':
			data = PREPAREDATA(memstat.dwAvailPhys, memstatex.ullAvailPhys);
			break;
		case 'f':
			data = PREPAREDATA(memstat.dwAvailPageFile, memstatex.ullAvailPageFile);
			break;

		case 'U':
			data = PREPAREDATA(memstat.dwTotalPhys, memstatex.ullTotalPhys)
					- PREPAREDATA(memstat.dwAvailPhys, memstatex.ullAvailPhys);
			break;
		case 'u':
			data = PREPAREDATA(memstat.dwTotalPageFile, memstatex.ullTotalPageFile)
					- PREPAREDATA(memstat.dwAvailPageFile, memstatex.ullAvailPageFile);
			break;

		default:
			destbuf[0] = '\0';
			return;
	}
	wsprintf(destbuf, T("%02d"), data);
	return;
}

DWORD GPUtick;
void GetGPUInfomation(TCHAR type, TCHAR *destbuf)
{
	DWORD tick;
#if USEGPUNV
	int gpuID = 0;
	unsigned long cnt;
	NvAPI_Status status;
	NvDisplayHandle hDisplay_a[NVAPI_MAX_PHYSICAL_GPUS * 2] = {0};
	static NvPhysicalGpuHandle nvGPUHandle;
	NV_DISPLAY_DRIVER_VERSION version = {0};
	NvAPI_ShortString shortstring;
	NvU32 temp = 0;
	static NV_GPU_THERMAL_SETTINGS set = {0};
	static BOOL NvAPILOAD = FALSE;

	tick = GetTickCount();
	if ( (tick - GPUtick) >= 500 ){
		GPUtick = tick;

		if ( NvAPILOAD == FALSE ){
			status = NvAPI_Initialize();
			if ( status != NVAPI_OK ){
				wsprintf(destbuf, T("NvAPI_Initialize: error %d"), status);
				return;
			}

			version.version = NV_DISPLAY_DRIVER_VERSION_VER;
			status = NvAPI_GetDisplayDriverVersion(NVAPI_DEFAULT_HANDLE, &version);
			if ( status != NVAPI_OK ){
				NvAPI_GetErrorMessage(status, shortstring);
				wsprintf(destbuf, "NvAPI_GetDisplayDriverVersion: %s", shortstring);
				return;
			}

			status = NvAPI_EnumNvidiaDisplayHandle(gpuID, &hDisplay_a[gpuID]);
			if ( status != NVAPI_OK ){
				NvAPI_GetErrorMessage(status, shortstring);
				wsprintf(destbuf, "NvAPI_EnumNvidiaDisplayHandle: %s", shortstring);
				return;
			}

			status = NvAPI_GetPhysicalGPUsFromDisplay(hDisplay_a[0], &nvGPUHandle, &cnt);
			if (status != NVAPI_OK){
				NvAPI_GetErrorMessage(status, shortstring);
				wsprintf(destbuf, "NvAPI_GetPhysicalGPUsFromDisplay: %s\n", shortstring);
				return;
			}
			NvAPILOAD = TRUE;
		}

		set.version = NV_GPU_THERMAL_SETTINGS_VER;
		set.count = 0;
		set.sensor[set.count].controller = NVAPI_THERMAL_CONTROLLER_UNKNOWN;
		set.sensor[set.count].target = NVAPI_THERMAL_TARGET_GPU;

		status = NvAPI_GPU_GetThermalSettings(nvGPUHandle, 0, &set);
		if (status != NVAPI_OK){
			NvAPI_GetErrorMessage(status, shortstring);
			wsprintf(destbuf, "NvAPI_GPU_GetThermalSettings: %s\n", shortstring);
			return;
		}
	}
	wsprintf(destbuf, "%02d", set.sensor[0].currentTemp);
//	NvAPI_Unload();
#endif
#if USEGPUATI
	static HANDLE hGPUAti = INVALID_HANDLE_VALUE;
	int ADL_Err;
	int iAdapterIndex = 0;
	int iActive;
	static ADLPMActivity ADLp;
	static ADLTemperature ADLt;

	tick = GetTickCount();
	if ( (tick - GPUtick) >= 500 ){
		GPUtick = tick;

		if ( hGPUAti == INVALID_HANDLE_VALUE ){
			hGPUAti = LoadLibraryA("atiadlxx.dll");
			if ( hGPUAti == NULL ) hGPUAti = LoadLibraryA("atiadlxy.dll");
			if ( hGPUAti != NULL ){
				GETDLLPROC(hGPUAti, ADL_Main_Control_Create);
				GETDLLPROC(hGPUAti, ADL_Main_Control_Destroy);
				GETDLLPROC(hGPUAti, ADL_Adapter_Active_Get);
				GETDLLPROC(hGPUAti, ADL_Overdrive5_CurrentActivity_Get);
				GETDLLPROC(hGPUAti, ADL_Overdrive5_Temperature_Get);

				ADL_Err = DADL_Main_Control_Create(ADL_Main_Memory_Alloc, 1);
				if ( ADL_Err == ADL_OK ){
					ADL_Err = DADL_Adapter_Active_Get(iAdapterIndex, &iActive);
					if ( (ADL_Err != ADL_OK) || (iActive == 0) ){
						FreeLibrary(hGPUAti);
						hGPUAti = NULL;
					}
				}
			}
		}
		if ( hGPUAti != NULL ){
			ADLp.iSize = sizeof(ADLp);
			DADL_Overdrive5_CurrentActivity_Get(iAdapterIndex, &ADLp);
			ADLt.iSize = sizeof(ADLt);
			DADL_Overdrive5_Temperature_Get(iAdapterIndex, 0, &ADLt);
		}
	}
	if ( hGPUAti == NULL ){
		tstrcpy(destbuf, T("ati not found"));
	}else{
		if ( type != 'r' ){ // %UGt
			wsprintf(destbuf, T("%d.%d"), ADLt.iTemperature / 1000, (ADLt.iTemperature % 1000) / 100);
		}else{ // %UGr
			wsprintf(destbuf, T("%3d"), ADLp.iActivityPercent);
		}
	}
#endif
}

void FixAndUnPaddingString(char *firstptr, int size)
{
	int offset, dest = 0;
	char *ptr;

	ptr = firstptr;
	for ( offset = 0 ; offset < size ; offset += 2 ){
		char tmpchar;

		tmpchar = ptr[offset];
		ptr[offset] = ptr[offset + 1];
		ptr[offset + 1] = tmpchar;
	}
	for ( offset = 0 ; offset < size ; offset++ ){
		if ( ptr[offset] == ' ' ) continue;
		ptr[dest++] = ptr[offset];
	}
	ptr[dest] = '\0';
}

void PrintAndCheckSMARTValue(TCHAR *buf, const TCHAR *title, int value, int *store, BOOL *hderr)
{
	wsprintf(buf, T("%s\t%02d"), title, value);
	if ( *store >= 0 ){
		int delta = *store - value;

		if ( delta ){
			*hderr = TRUE;
			if ( delta < 0 ) delta = -delta;
			wsprintf(buf + tstrlen(buf), T("(+%d)"), delta);
		}
	}
	*store = value;
}

struct SMARTMSGSstruct {
	BYTE smartid;
	int msgid;
} SMARTMSGS[] = {
	{ 0x01, MSG_HDDSMART01 },
	{ 0x02, MSG_HDDSMART02 },
	{ 0x03, MSG_HDDSMART03 },
	{ 0x04, MSG_HDDSMART04 },
	{ 0x05, MSG_HDDSMART05 },
	{ 0x07, MSG_HDDSMART07 },
	{ 0x08, MSG_HDDSMART08 },
	{ 0x09, MSG_HDDSMART09 },
	{ 0x0A, MSG_HDDSMART0A },
	{ 0x0B, MSG_HDDSMART0B },
	{ 0x0C, MSG_HDDSMART0C },
	{ 0x0D, MSG_HDDSMART0D },
	{ 0xB5, MSG_HDDSMARTB5 },
	{ 0xB8, MSG_HDDSMARTB8 },
	{ 0xBB, MSG_HDDSMARTBB },
	{ 0xBC, MSG_HDDSMARTBC },
	{ 0xBF, MSG_HDDSMARTBF },
	{ 0xC0, MSG_HDDSMARTC0 },
	{ 0xC1, MSG_HDDSMARTC1 },
	{ 0xC5, MSG_HDDSMARTC5 },
	{ 0xC8, MSG_HDDSMARTC8 },
	{ 0xF1, MSG_HDDSMARTF1 },
	{ 0xF2, MSG_HDDSMARTF2 },
	{ 0, 0 },
};

void SetDiskInformainMenu(HMENU hParentMenu)
{
	int driveno;
	char pipebuf[PipeBuffers];
	char buf[0x80];
#ifdef UNICODE
	TCHAR bufW[0x80];
#else
	#define bufW buf
#endif

	TCHAR diskid[0x80];
	DWORD getsize, getsize2 = 0;
	int bWarrantyThreshold;

	CFG cfg;
	TCHAR *cfgp, i_date[16];
	int i_c4, i_c6, i_c7;

	cfg.bottom = NULL;
	for ( driveno = 1 ; driveno <= 9 ; driveno++ ){
		buf[0] = 'H';
		buf[1] = 'I';
		buf[2] = (char)(driveno + '0');
		buf[3] = '\0';
		getsize = GetHWINFSdata(buf, 4, pipebuf, sizeof(pipebuf));

		if ( getsize && !((getsize == 2) && !strcmp(pipebuf, "!")) ){
			HMENU hHdMenu;
			DRIVEATTRIBUTE *da, *damax;
			ATTRIBUTETHRESHOLD *at, *atmax, *atdef, *atn;
			BOOL hderr = FALSE;

			hHdMenu = CreatePopupMenu();
			FixAndUnPaddingString(pipebuf + 20, 20);
			FixAndUnPaddingString(pipebuf + 54, 40);
#ifdef UNICODE
			wsprintfA(buf, "%s\t%s", pipebuf + 54, pipebuf + 20);
			AnsiToUnicode(buf, diskid, 0x80);
#else
			wsprintf(diskid, T("%s\t%s"), pipebuf + 54, pipebuf + 20);
#endif
			AppendMenu(hHdMenu, MF_ES, 0, diskid);
			diskid[strlen(pipebuf + 54)] = '-';

			if ( cfg.bottom == NULL ) CFGOpen(&cfg, cfgfile);
			if ( cfg.bottom != NULL ){
				cfgp = CFGFindKey(&cfg, diskid, bufW, TSIZEOF(bufW));
				if ( cfgp != NULL ){
					tstrcpy(i_date, CFGFixParam(cfgp, &cfgp));
					i_c4 = GetNumberNC(&cfgp);
					CFGFixParam(cfgp, &cfgp);
					i_c6 = GetNumberNC(&cfgp);
					CFGFixParam(cfgp, &cfgp);
					i_c7 = GetNumberNC(&cfgp);
				}else{
					wsprintf(i_date, T("%d-%02d-%02d"), ltime.wYear, ltime.wMonth, ltime.wDay);
					i_c4 = -1;
					i_c6 = -1;
					i_c7 = -1;
				}
			}else{
				cfgp = NULL;
			}

			buf[0] = 'H';
			buf[1] = 'B';
			buf[2] = (char)(driveno + '0');
			buf[3] = '\0';
			getsize = GetHWINFSdata(buf, 4, pipebuf, sizeof(pipebuf));
			if ( OldHWINFS && (getsize > 0) && (getsize <= 2) ){
				buf[0] = 'H';
				buf[1] = 'S';
				buf[2] = (char)(driveno + '0');
				buf[3] = '\0';
				getsize = GetHWINFSdata(buf, 4, pipebuf, sizeof(pipebuf));

				da = (DRIVEATTRIBUTE *)(pipebuf + 2);
				damax = (DRIVEATTRIBUTE *)(pipebuf + getsize);
			}else{
				getsize2 = *(DWORD *)pipebuf;
				da = (DRIVEATTRIBUTE *)(pipebuf + 2 + sizeof(DWORD));
				damax = (DRIVEATTRIBUTE *)(pipebuf + sizeof(DWORD) + getsize2);
				atn = atdef = (ATTRIBUTETHRESHOLD *)((BYTE *)damax + 2);
				atmax = (ATTRIBUTETHRESHOLD *)(pipebuf + sizeof(DWORD) + getsize);
			}

			if ( getsize && !((getsize == 2) && !strcmp(pipebuf, "!")) ){
				for ( ; da < damax ; da++ ){
					TCHAR *dest;

					if ( da->bAttrID == 0 ) break;
					dest = bufW;
					*dest = 0;

					bWarrantyThreshold = 0;
					if ( getsize2 > 0 ){
						if ( (atn < atmax) && (atn->bAttrID == da->bAttrID) ){
							bWarrantyThreshold = atn->bWarrantyThreshold;
						}else{
							at = atdef;
							for (;;){
								if ( at->bAttrID == 0 ) break;
								if ( at->bAttrID == da->bAttrID ){
									bWarrantyThreshold = at->bWarrantyThreshold;
									break;
								}
								at++;
								if ( at >= atmax ) break;
							}
						}
						atn++;
					}
					if ( (da->bAttrValue >= da->bWorstValue) &&
						 ( (da->bAttrValue <= bWarrantyThreshold) ||
						   (da->bWorstValue <= bWarrantyThreshold) ) ){
						dest += wsprintf(dest, TMsg(HDDSMARTMOD));
						hderr = TRUE;
					}

					switch ( da->bAttrID ){
						case 0xc2:
							wsprintf(dest, TMsg(HDDSMARTTEMP), da->bRawValue[0]);
							break;

						case 0xc4:
							PrintAndCheckSMARTValue(bufW, TMsg(HDDSMARTSSEC),
									da->bAttrValue, &i_c4, &hderr);
							break;

						case 0xc6:
							PrintAndCheckSMARTValue(bufW, TMsg(HDDSMARTBSEC),
									da->bAttrValue, &i_c6, &hderr);
							break;

						case 0xc7:
							PrintAndCheckSMARTValue(bufW, TMsg(HDDSMARTCRC),
									da->bAttrValue, &i_c7, &hderr);
							break;

						default: {
							struct SMARTMSGSstruct *ss;
							const TCHAR *msg;

							msg = NilStr;
							ss = SMARTMSGS;
							for ( ; ss->smartid != 0 ; ss++ ){
								if ( da->bAttrID == ss->smartid ){
									msg = TMsgStr[ss->msgid];
									break;
								}
							}
							if ( bWarrantyThreshold > 0 ){
								wsprintf(dest,
										T("%s(%02X)\t%02d %02d/%02d %08x"),
										msg, da->bAttrID,
										da->bAttrValue, da->bWorstValue,
										bWarrantyThreshold,
										*(DWORD *)da->bRawValue);
							}else{
								wsprintf(dest,
										T("%s(%02X)\t%02d %02d %08x"),
										msg, da->bAttrID,
										da->bAttrValue, da->bWorstValue,
										*(DWORD *)da->bRawValue);
							}
						}
					}
					AppendMenu(hHdMenu, MF_ES, 0, bufW);
				}
			}
			wsprintf(bufW, T("Drive #%d"), driveno);
			if ( hderr != FALSE ) tstrcat(bufW, TMsg(HDDSMARTMOD));
			AppendMenu(hParentMenu, MF_EPOP, (UINT_PTR)hHdMenu, bufW);
			if ( (cfg.bottom != NULL) && (cfgp == NULL) ){
				// SMART̏lL
				wsprintf( bufW, T( "%s,%d,%d,%d" ), i_date, i_c4, i_c6, i_c7 );
				CFGReplaceLine(&cfg, 0, diskid, bufW);
			}
		}
	}
	CFGClose(&cfg);
}
