/*-----------------------------------------------------------------------------
	ClockPod / E-mail `FbN										(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <string.h>
#include <Winsock.h>
#include "CLOCKPOD.H"

#define MAX_BUF 0x1000

#define MAILERR_GENERIC	-1
#define MAILERR_LOADDLL	-2
#define MAILERR_WSOCK	-3
#define MAILERR_CONNECT	-4
#define MAILERR_PASSWORD	-5
#define MAILERR_NOSSL	-6
#define MAILERR_MAX	-6

static const TCHAR *Errors[] = {
	T("1Mail Check"), T("1No wsock32.dll"), T("1WinSock"),
	T("1Server connect"), T("1Password"),
	T("1No ssleay32.dll")};
static const char *monthstr[] =
	{"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	 "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", NULL};
//================================================================= WinSock DLL
typedef struct impaddrinfo {
	int ai_flags;
	int ai_family;
	int ai_socktype;
	int ai_protocol;
	size_t ai_addrlen;
//	TCHAR *ai_canonname;
	char *ai_canonname;
	struct sockaddr *ai_addr;
	struct impaddrinfo *ai_next;
} impADDRINFO;

HANDLE hWSOCK32 = NULL;
DefineWinAPI(int, recv, (SOCKET s, char *buf, int len, int flags));
DefineWinAPI(int, send, (SOCKET s, const char *buf, int len, int flags));
DefineWinAPI(int, WSAStartup, (WORD wVersionRequested, LPWSADATA lpWSAData));
DefineWinAPI(SOCKET, socket, (int af, int type, int protocol));
DefineWinAPI(unsigned long, inet_addr, (const char *cp));
DefineWinAPI(struct hostent *, gethostbyname, (const char *name));
DefineWinAPI(int, connect, (SOCKET s, const struct sockaddr *name, int namelen));
DefineWinAPI(int, closesocket, (SOCKET s));
DefineWinAPI(int, WSACleanup, (void));
DefineWinAPI(u_short, htons, (u_short hostshort));
DefineWinAPI(int, shutdown, (SOCKET s, int how));
DefineWinAPI(int, select, (int nfds, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, const struct timeval *timeout));

LOADWINAPISTRUCT WSOCK32DLL[] = {
	LOADWINAPI1(recv),
	LOADWINAPI1(send),
	LOADWINAPI1(WSAStartup),
	LOADWINAPI1(socket),
	LOADWINAPI1(inet_addr),
	LOADWINAPI1(gethostbyname),
	LOADWINAPI1(connect),
	LOADWINAPI1(closesocket),
	LOADWINAPI1(WSACleanup),
	LOADWINAPI1(htons),
	LOADWINAPI1(shutdown),
	LOADWINAPI1(select),
	{NULL, NULL}
};

#ifdef UNICODE
	#define GETADDRINFONAME "getaddrinfo"
	#define FREEADDRINFONAME "freeaddrinfo"
#else
	#define GETADDRINFONAME "getaddrinfo"
	#define FREEADDRINFONAME "freeaddrinfo"
#endif

//DefineWinAPI(int, getaddrinfo, (CTCHAR *pNodeName, CTCHAR *pServiceName, const impADDRINFO *pHints, impADDRINFO **ppResult));
DefineWinAPI(int, getaddrinfo, (const char *pNodeName, const char *pServiceName, const impADDRINFO *pHints, impADDRINFO **ppResult));
DefineWinAPI(void, freeaddrinfo, (impADDRINFO *pAddrInfo));
//================================================================= OpenSSL DLL
HANDLE hSsleay32 = NULL;
#define DefineCdeclAPI(retvar, name, param) typedef retvar (CDECL *imp ## name) param; imp ## name D ## name

typedef void SSL;
typedef void SSL_CTX;
typedef void SSL_METHOD;

DefineCdeclAPI(SSL_CTX *, SSL_CTX_new, (SSL_METHOD *meth));
DefineCdeclAPI(void, SSL_CTX_free, (SSL_CTX *));
DefineCdeclAPI(int, SSL_set_fd, (SSL *s, int fd));
DefineCdeclAPI(SSL *, SSL_new, (SSL_CTX *ctx));
DefineCdeclAPI(void, SSL_free, (SSL *ssl));
DefineCdeclAPI(int, SSL_connect, (SSL *ssl));
DefineCdeclAPI(int, SSL_read, (SSL *ssl, void *buf, int num));
DefineCdeclAPI(int, SSL_peek, (SSL *ssl, void *buf, int num));
DefineCdeclAPI(int, SSL_write, (SSL *ssl, const void *buf, int num));
DefineCdeclAPI(long, SSL_CTX_ctrl, (SSL_CTX *ctx, int cmd, long larg, void *parg));
DefineCdeclAPI(int, SSL_shutdown, (SSL *s));

// API 1.01 O
DefineCdeclAPI(int, SSL_library_init, (void));
DefineCdeclAPI(void, SSL_load_error_strings, (void));

// VAPI 1.01 ȍ~
#ifdef _WIN64
	typedef unsigned long long int OPTS_VALUE;
	#define OPTS_VALUE_INIT 0
	#define OPTS_VALUE_LOAD LOAD_ERROR_STRINGS_OPT
#else
	typedef struct { DWORD dummy[2]; } OPTS_VALUE_struct;
	#define OPTS_VALUE OPTS_VALUE_struct
	#define OPTS_VALUE_INIT {{0, 0}}
	#define OPTS_VALUE_LOAD {{LOAD_ERROR_STRINGS_OPT, 0}}
#endif
// OPENSSL_INIT_LOAD_SSL_STRINGS | OPENSSL_INIT_LOAD_CRYPTO_STRINGS
#define LOAD_ERROR_STRINGS_OPT 0x200002L
DefineCdeclAPI(int, OPENSSL_init_ssl, (OPTS_VALUE, void *));
DefineCdeclAPI(SSL_METHOD *, TLS_client_method, (void));

LOADWINAPISTRUCT SSLEAY32DLL[] = {
	LOADWINAPI1(SSL_CTX_new),
	LOADWINAPI1(SSL_CTX_free),
	LOADWINAPI1(SSL_set_fd),
	LOADWINAPI1(SSL_new),
	LOADWINAPI1(SSL_free),
	LOADWINAPI1(SSL_connect),
	LOADWINAPI1(SSL_read),
	LOADWINAPI1(SSL_peek),
	LOADWINAPI1(SSL_write),
	LOADWINAPI1(SSL_CTX_ctrl),
	LOADWINAPI1(SSL_shutdown),
	{NULL, NULL}
};

#define SSL_CTRL_MODE 33
#define SSL_MODE_AUTO_RETRY 0x00000004L
#define DSSL_CTX_set_mode(ctx, op) DSSL_CTX_ctrl((ctx), SSL_CTRL_MODE, (op), NULL)

// -------------------------
typedef struct {
	SOCKET sock;
	SSL *ssl;
} SSOCKET;

#ifdef UNICODE
unsigned char USEFASTCALL IsEOLA(LPCSTR *str)
{
	unsigned char code;

	code = **str;
	if ( code == 0 ) return 0;
	if ( code == 0xd ){
		if ( *(*str + 1) == 0x0a ) (*str)++;
		return 0;
	}
	if ( code == 0xa ){
		if ( *(*str + 1) == 0x0d ) (*str)++;
		return 0;
	}
	return code;
}

unsigned char GetLineParamA(LPCSTR *str, char *param)
{
	unsigned char code, bottom;
	const char *src;
	char *dst;

	src = *str;
	dst = param;
	for(;;){
		bottom = *src;
		if ( (bottom == ' ') || (bottom == '\t') ){
			src++;
			continue;
		}
		break;
	}
	if ( bottom == '\0' ){
		*str = src;
		return 0;
	}
	src++;
	if ( bottom == '\"' ){
		bottom = *src;
		while( 0 != (code = IsEOLA(&src)) ){
			src++;
			if ( (code == '\"') && (*src <= ' ') )	break;
			*dst++ = code;
		}
	}else{
		*dst++ = bottom;
		while( 0 != (code = IsEOLA(&src)) ){
			src++;
			if (code <= ' ')	break;
			*dst++ = code;
		}
	}
	*dst = 0;
	*str = src;
	return bottom;
}
#else
#define GetLineParamA(str, param) GetLineParam(str, param)
#endif

//=========================================================================
void DumpMail(char *title, char *text, char *max, int mailID)
{
	TCHAR filename[MAX_PATH], *fp;
	HANDLE hFile;
	DWORD size;

	tstrcpy(filename, cfgfile);
	fp = tstrrchr(filename, '\\') + 1;
	wsprintf(fp, T("%02d%02d-%02d%02d%02d%04d.html"),
		ltime.wMonth, ltime.wDay, ltime.wHour, ltime.wMinute, ltime.wSecond, mailID);
	hFile = CreateFile(filename,
			GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if ( hFile != INVALID_HANDLE_VALUE ){
		char *p;

		for ( p = text ; p < max ; p += strlen(p) + 1 ){
			WriteFile(hFile, p, (DWORD)strlen(p), &size, NULL);
			WriteFile(hFile, "\r\n", 2, &size, NULL);
		}
		WriteFile(hFile, title, (DWORD)strlen(title), &size, NULL);
		WriteFile(hFile, "\r\n", 2, &size, NULL);
		CloseHandle(hFile);
	}
}

//------------------------------------- Ps擾
BOOL wsGets(SSOCKET *ssock, char *str)
{
	int n, of = 0;
	char buf[MAX_BUF + 1];
	char *find;

	for(;;){
		fd_set fds;
		struct timeval timeout;

		if ( MailCheckBreak ) return FALSE;
		if ( ssock->ssl == NULL ){
			FD_ZERO(&fds);
			FD_SET(ssock->sock, &fds);
			timeout.tv_sec = 60;
			timeout.tv_usec = 0;
			if ( Dselect(0, &fds, NULL, NULL, &timeout) != 1 ) return FALSE;

				//Ƃ肠AMobt@ɂf[^s[N
			n = Drecv(ssock->sock, buf, sizeof(buf) - 1, MSG_PEEK);
		}else{
			n = DSSL_peek(ssock->ssl, buf, sizeof(buf) - 1);
		}

		if ( n <= 0 ) return FALSE;
		buf[n] = '\0';
		find = strstr(buf, "\r\n");
		if ( find ){
			if ( ssock->ssl == NULL ){
				n = Drecv(ssock->sock, str + of, (int)(find - buf + 2), 0);
			}else{
				n = DSSL_read(ssock->ssl, str + of, (int)(find - buf + 2));
			}
			if ( n <= 0 ) return FALSE;
			*(str + of + n - 2) = '\0';
			return TRUE;
		}
		if ( ssock->ssl == NULL ){
			n = Drecv(ssock->sock, str + of, n, 0);
		}else{
			n = DSSL_read(ssock->ssl, str + of, n);
		}
		if ( n <= 0 ) return FALSE;
		*(str + of + n) = '\0';
		of += n;
	}
}

//------------------------------------- PsMis͓ŕtj
BOOL wsPuts(SSOCKET *ssock, const char *str)
{
	char buf[MAX_BUF + 4];
	int i = 0, n, len;

	strcpy(buf, str);
	strcat(buf, "\r\n");
	len = (int)strlen(buf);
	do{
		if ( MailCheckBreak ) return FALSE;
		if ( ssock->ssl == NULL ){
			n = Dsend(ssock->sock, buf + i, len, 0);
		}else{
			n = DSSL_write(ssock->ssl, buf + i, len);
		}
		if ( (n == 0) || (n == SOCKET_ERROR) ) return FALSE;
		i += n;
		len -= n;
	}while( len > 0 );
	return TRUE;
}
/*
void ConnectProxy(SSOCKET *ssock, char *proxydom)
{
	char buf[MAX_BUF];
	int getlen;

	wsprintfA(buf, "CONNECT %s HTTP/1.1\r\n", proxydom + 1);
	if ( wsPuts(ssock, buf) == FALSE ){
		return;
	}
		MessageA(buf);
	getlen = Drecv(ssock->sock, buf, sizeof(buf) - 1, 0);
	if ( getlen < 0 ) return;
	buf[getlen] = '\0';
	if ( strstr(buf, " 200") == NULL ){ // 200 ȊO͎s
		MessageA(buf);
		MessageA("fault");
		return;
	}
	MessageA("ok");
	return;
}
*/
//=========================================================================
// Base 64 decode -------------------------------------------------------------
#define B64FLAG_D	B6
#define B64FLAG_ERR	B7
BYTE B64DecodeByte(BYTE code)
{
	char flags = T_CHRTYPE[code];

	if ( flags & T_IS_UPP ) return (BYTE)(code - 'A');
	if ( flags & T_IS_LOW ) return (BYTE)(code - 'a' + 26);
	if ( flags & T_IS_DIG ) return (BYTE)(code - '0' + 52);
	if ( code == '+') return 62;
	if ( code == '/') return 63;
	if ( code == '=') return B64FLAG_D;
	return B64FLAG_ERR;
}
// Base 64 decode -------------------------------------------------------------
int B64DecodeBytes(BYTE **src, BYTE *dst)
{
	BYTE work[4];
	int i;

	for ( i = 0 ; i < 4 ; i++ ){
		if ( (work[i] = B64DecodeByte(**src)) & B64FLAG_ERR ) break;
		(*src)++;
		if ( work[i] & B64FLAG_D ){
			for ( i++ ; i < 4 ; i++ ){
				if ( **src != '=' ) break;
				(*src)++;
			}
			break;
		}
	}
	if ( (work[0] | work[1]) & (B64FLAG_D | B64FLAG_ERR) ) return 0;
	*dst = (BYTE)((work[0] << 2) | (work[1] >> 4));

	if ( work[2] & (B64FLAG_D | B64FLAG_ERR) ) return 1;
	*(dst + 1) = (BYTE)((work[1] << 4) | (work[2] >> 2));

	if ( work[3] & (B64FLAG_D | B64FLAG_ERR) ) return 2;
	*(dst + 2) = (BYTE)((work[2] << 6) | work[3]);
	return 3;
}

int GetHex(BYTE c)
{
	CharUPR(c);
	c -= (BYTE)'0';
	if ( c > 9 ) c = (BYTE)( c - 7 );
	return c;
}

#define CODE_JIS	1
#define CODE_UTF7	2
#define CODE_UTF8	3
#define CODE_SJIS	4
#define CODE_MAX	5

typedef struct {
	DWORD cp;
	char *cptext;
} CPTEXTS;

CPTEXTS cptext[] = {
	{CODE_JIS, "iso-2022-jp"},
	{28591, "iso-8859-1"},
	{CODE_UTF7, "UTF-7"},
	{CODE_UTF8, "UTF-8"},
	{CODE_SJIS, "SHIFT_JIS"},
	{0, NULL}
};

const TCHAR CodePageListPath[] = T("Software\\Classes\\MIME\\Database\\Charset");
const TCHAR CodePageName[] = T("InternetEncoding");
const TCHAR CodePageAliasName[] = T("AliasForCharset");
DWORD GetCodePage(BYTE **text)
{
#define CPBUFSIZE 20
	CPTEXTS *cpt;
	BYTE *textsrc;
	HKEY HKroot, HKitem;
	DWORD cp = 0;
	BOOL loop = FALSE;
	TCHAR textbuf[CPBUFSIZE], *textdest;

	for ( cpt = cptext ; cpt->cp ; cpt++ ){
		size_t len;

		len = strlen(cpt->cptext);
		if ( !memicmp(*text, cpt->cptext, len) &&
			 ((cpt->cp < CODE_MAX) || IsValidCodePage(cpt->cp)) ){
			*text += len;
			return cpt->cp;
		}
	}
	// WXg MIME 画ʂ(Win2k/Win98ȍ~)
	textsrc = *text;
	textdest = textbuf;
	for (;;){
		BYTE chr;

		chr = *textsrc;
		if ( (chr <= '\"') || (chr == '?') || (chr == ';') ) break;
		if ( textdest >= (textbuf + CPBUFSIZE - 2) ) return 0;
		*textdest++ = (WCHAR)chr;
		textsrc++;
	}
	*textdest = '\0';
	if ( RegOpenKeyEx(HKEY_LOCAL_MACHINE, CodePageListPath, 0, KEY_READ, &HKroot) !=
			ERROR_SUCCESS ){
		return 0;
	}
	for (;;){
		DWORD s, t;

		if ( RegOpenKeyEx(HKroot, textbuf, 0, KEY_READ, &HKitem) != ERROR_SUCCESS ){
			break;
		}

		s = sizeof cp;
		if ( ERROR_SUCCESS == RegQueryValueEx(HKitem, CodePageName, NULL, &t, (LPBYTE)&cp, &s) ){
			if ( cp != 0 ) *text += textdest - textbuf;
		}else{
			s = sizeof textbuf;
			if ( (loop == FALSE) && (ERROR_SUCCESS == RegQueryValueEx(HKitem, CodePageAliasName, NULL, &t, (LPBYTE)&textbuf, &s)) ){
				loop = TRUE;
				RegCloseKey(HKitem);
				continue;
			}
		}
		RegCloseKey(HKitem);
		break;
	}
	RegCloseKey(HKroot);
	return cp;
}

BOOL MimeDecode(const char **text, const char *textmax, char **destbuf, char *destmax)
{
	BYTE *tp;
	DWORD codetype;
	BYTE *src, *dest, *srcmax;
	WCHAR bufw[MAX_BUF];

	// ?ISO-2022-JP?B?
	//  ^
	tp = (BYTE *)*text + 2;

	codetype = GetCodePage(&tp);
	if ( (codetype != 0) && (*tp == '?') ){
		tp++;
	}else{
		return FALSE;
	}
	if ( *(tp + 1) != (BYTE)'?' ) return FALSE;

	src = tp + 2;
	dest = (BYTE *)*destbuf;

	if ( upper((char)*tp) == 'B' ){	// BASE64
		int len;

		do{
			len = B64DecodeBytes(&src, dest);
			if ( len == 0 ) break;
			dest += len;
			if ( dest >= (BYTE *)destmax ) break;
		}while( len == 3 );
	}else if ( upper((char)*tp) == 'Q' ){	// quoted
		while( src < (BYTE *)textmax ){
			if ( dest >= (BYTE *)destmax ) break;
			if ( *src == '?' ) break;
			if ( *src != '=' ){
				*dest++ = *(BYTE *)src++;
				continue;
			}
			src++;
			if ( (*src == '\r') && (*(src + 1) == '\n') ){
				src += 2;
				continue;
			}
			if ( Isxdigit(*src) && Isxdigit(*(src+1)) ){
				*dest++ = (BYTE)((GetHex(*src) * 16) + GetHex(*(src+1)));
				src += 2;
				continue;
			}
			return FALSE;
		}
	}else{
		return FALSE;
	}
	if ( (*src == '?') && (*(src + 1) == '=' ) ) src += 2;
	*dest = '\0';
	srcmax = dest;
	*text = (char *)src;

	// 󔒃XLbvłȂAB
	for (;;){
		BYTE c;

		c = *src;
		if ( (c == '\0') || (c > ' ') ){
			if ( (c == '=') && (*(src + 1) == '?') ){ //  MIME
				*text = (char *)src;
			}
			break;
		}
		src++;
	}

	switch( codetype ){
		case CODE_UTF8: {		// UTF8ANSI ϊ
		#ifdef UNICODE
			src = dest = (BYTE *)*destbuf;
			dest += strlen((char *)dest);
			while ( dest < srcmax ){
				if ( *dest == '\0' ) *dest = '.';
				dest++;
			}
			*dest = '\0';
		#else
			WCHAR *srcw, c;

			src = dest = (BYTE *)*destbuf;
			srcw = bufw;
			while ( src < srcmax ){
				c = *src++;
				if ( !(c & B7) ){
					*srcw++ = (c == '\0') ? L'?' : c;
					continue;
				}
				if ( (c & 0xe0) == 0xc0 ){
					*srcw++ = (WCHAR)(( c & 0x1f  )		<<  6) |
							(WCHAR)((*src) & 0x3f );
					src++;
					continue;
				}
				if ( (c & 0xf0) == 0xe0 ){
					*srcw++ = (WCHAR)(( c & 0xf  )		<< 12) |
							(WCHAR)(( *src & 0x3f )		<<  6) |
							(WCHAR)(*(src + 1) & 0x3f );
					src += 2;
					continue;
				}
				if ( (c & 0xf8) == 0xf0 ){
					DWORD c32 = (WCHAR)(( c & 7 )			<< 18) |
							(WCHAR)(( *src & 0x3f )		<< 12) |
							(WCHAR)((*(src + 1) & 0x3f )	<<  6) |
							(WCHAR)(*(src + 2) & 0x3f );
					src += 3;

					*srcw++ = (WORD)(DWORD)((c32 >> 10) + (0xd800 - (0x10000 >> 10)));
					*srcw++ = (WORD)(DWORD)((c32 & 0x3ff) | 0xdc00);
					continue;
				}
				*srcw++ = '?';
/*	݁AKiŎgpĂȂ
				if ( (c & 0xfc) == 0xf8 ){
					*srcw++ = (WCHAR)(( c & 3 )			<< 24) |
							(WCHAR)(( *src & 0x3f )		<< 18) |
							(WCHAR)((*(src + 1) & 0x3f )	<< 12) |
							(WCHAR)((*(src + 2) & 0x3f )	<<  6) |
							(WCHAR)(*(src + 3) & 0x3f );
					src += 4;
					continue;
				}
				if ( (c & 0xfe) == 0xfc ){
					*srcw++ = (WCHAR)(( c & 1 )			<< 30) |
							(WCHAR)(( *src & 0x3f )		<< 24) |
							(WCHAR)((*(src + 1) & 0x3f )	<< 18) |
							(WCHAR)((*(src + 2) & 0x3f )	<< 12) |
							(WCHAR)((*(src + 3) & 0x3f )	<<  6) |
							(WCHAR)(*(src + 4) & 0x3f );
					src += 5;
					continue;
				}
*/
			}
			*srcw = '\0';
			UnicodeToAnsi(bufw, (char *)dest, MAX_BUF);
			dest += strlen((char *)dest);
		#endif
			break;
		}

		case CODE_JIS: {
			BOOL jisstate = FALSE;

			dest = (BYTE *)*destbuf;
			for ( src = dest ; src < srcmax ; src++ ){
				int c1, c2;

				c1 = *src;
				c2 = *(src + 1);
				if ( c1 == '\x1b' ){
					if ( (c2 == '(') &&
							((*(src+2) == 'B') || (*(src+2) == 'J')) ){
						src += 2;
						jisstate = FALSE;
						continue;
					}
					if ( (c2 == '$') &&
							((*(src+2) == 'B') || (*(src+2) == '@')) ){
						src += 2;
						jisstate = TRUE;
						continue;
					}
					continue;
				}
				if ( jisstate == FALSE ){
					*dest++ = (BYTE)c1;
					continue;
				}
				src++;
				// JISShift_JIS ϊ
				if ( (c1 < 0x21) || (c1 >= 0x7f) || (c2 < 0x21) || (c2 >= 0x7f) ){
					*dest++ = (BYTE)c1;
					*dest++ = (BYTE)' ';
					continue;
				}
				if ( c1 & 1 ) {
					if ( c2 < 0x60 ) c2 += 0x1F;
					else			c2 += 0x20;
				} else				c2 += 0x7E;
				if ( c1 < 0x5F )	c1 = (c1 + 0xE1) >> 1;
				else				c1 = (c1 + 0x161) >> 1;

				*dest++ = (unsigned char)c1;
				*dest++ = (unsigned char)c2;
			}
			#ifdef UNICODE
			*dest = '\0';
			codetype = CP__SJIS;

			MultiByteToWideChar(codetype, MB_PRECOMPOSED, *destbuf, -1, bufw, MAX_BUF);
			UnicodeToUtf8(bufw, *destbuf, MAX_BUF);
			dest = (BYTE *)(*destbuf + strlen(*destbuf));
			#endif
			break;
		}
		default:
			for ( src = (BYTE *)*destbuf ; src < srcmax ; src++ ){
				if ( *src == '\0' ) *src = '?';
			}
			MultiByteToWideChar(codetype, MB_PRECOMPOSED, *destbuf, -1, bufw, MAX_BUF);
			#ifdef UNICODE
				UnicodeToUtf8(bufw, *destbuf, MAX_BUF);
			#else
				UnicodeToAnsi(bufw, *destbuf, MAX_BUF);
			#endif
			dest = (BYTE *)(*destbuf + strlen(*destbuf));
			break;
	}
	*dest = '\0';
	*destbuf = (char *)dest;
	return TRUE;
}

BOOL GetInfo(char *dest, const char *src, const char *srcmax)
{
	const char *ptr;
	char *destmax;
	BOOL spam = FALSE;

	ptr = src - 1;
	destmax = dest + MAX_BUF - 64;

	while( (*(ptr + 1) == ' ') || (*(ptr + 1) == '\t') ){
		ptr++;
		while ( (*ptr == ' ') || (*ptr == '\t') ) ptr++;
		while ( *ptr && (destmax > dest) ){
			if ( (*ptr == '=') && (*(ptr + 1) == '?') ){
				if ( MimeDecode(&ptr, srcmax, &dest, destmax) != FALSE ){
					continue;
				}
			}
			if ( *ptr & B7 ) spam = TRUE;
			*dest++ = *ptr++;
		}
	}
	*dest = '\0';
	return spam;
}
//=========================================================================
// t{ɏC
void FixDate(char *date)
{
	int month;
	char day[100], buf[100];
	const char **m, *p;

	p = date;
	if ( Isalpha(*p) ) GetLineParamA(&p, buf);	// j
	day[0] = '\0';
	GetLineParamA(&p, day);	// 
	GetLineParamA(&p, buf);	// 

	for ( m = monthstr, month = 1 ; *m != NULL ; m++, month++ ){
		if ( !stricmp(buf, *m) ) break;
	}

	GetLineParamA(&p, buf);	// N
	GetLineParamA(&p, buf);	// 
	buf[5] = '\0';

	wsprintfA(date, "%2d/%s %s", month, day, buf);
}

#define IDLEN 80	// ۑ\ id 
#define ETCSTR "etc...,"
typedef struct {
	int points;		// ݐσ|Cg
	BOOL full;		// ߂ȂȂǂ̃`FbN
	char ID[IDLEN];	// o ID̗
} SPAMINFO;

// usembox ̏
#define MBOX_UNKNOWN	0 // m / 
#define MBOX_INSERVER	1 // T[ooR
#define MBOX_ENTER		2 // T[ot

typedef struct {
	int count;			// L Received: ̐
	BOOL check;			// JEg邩ǂ
	int usembox;		// mbox ̃`FbN
	char mbox[MAX_BUF];	// MAJEg̃T[o
} RECEIVEDINFO;

void SetSpam(SPAMINFO *si, int points, const char *ID)
{
	si->points += points;
	if ( si->full != FALSE ) return;
	if ( (strlen(si->ID) + strlen(ID)) < (IDLEN - 2 - sizeof(ETCSTR)) ){
		strcat(si->ID, ID);
		strcat(si->ID, ",");
	}else{
		strcat(si->ID, ETCSTR);
		si->full = TRUE;
	}
}

// From: / To: `FbN
void AddrCheck(SPAMINFO *si, const char *src, const char *max, char *addr)
{
	int ptr = 0;

	if ( (GetInfo(addr, src, max) != FALSE) || strchr(addr, '\x1b') ){
		SetSpam(si, X_spAddr, "*AddrCode");
	}
	if ( strchr(addr, '@') == NULL ) ptr++;
	if ( strstr(addr, "\"@") ) ptr++;
	if ( ptr ) SetSpam(si, X_spAddr * ptr, "*addr");
}

// Received: wb_`FbN ( [form (fromip)] by (receivedip) [for (mailaddr)])
void CheckReceived(RECEIVEDINFO *ri, char *header)
{
	char *p, *pq, *byptr = NULL;
								// by ؂o
	p = header;
	while( *p ){
		if ( !memcmp(p, "by ", 3) ){
			*p = '\0';
			p += 3;
			byptr = p;
			continue;
		}
		if ( *p == '[' ){
			pq = strchr(p, ']');
			if ( pq == NULL ) break;
			p = pq + 1;
			continue;
		}
		if ( *p == '(' ){
			pq = strchr(p, ')');
			if ( pq == NULL ) break;
			p = pq + 1;
			continue;
		}
		p++;
	}
	if ( byptr == NULL ) return;	// by ȂpłȂ Received:
	ri->count++;
	if ( ri->count == 1 ){	// ŏ Received:  T[o𒊏o
		char *bytop;
		char *serverlast = NULL, *last;
		int level = 0;

		ri->mbox[0] = '\0';
		bytop = p = byptr;

		while( (BYTE)*bytop <= (BYTE)' ' ) bytop++;	// 󔒃XLbv
		p = bytop;
		while( (BYTE)*p > (BYTE)' ' ) p++;			// T[o̖ֈړ
					// ..[.name.]com ..[.name.]jp ..[.name.]ne.jp o
		last = p;
		while ( p > bytop ){
			p--;
			if ( *p != '.' ) continue;
			level++;
			if ( level == 1 ){
				if ( (last - p) >= 4 ){ 		//.com .info 
					serverlast = p + 1;
					continue;
				}
				last = p;
				continue;
			}else if ( level == 2 ){
				if ( serverlast != NULL ){		// .com .info 擾I
					break;
				}else if ( (last - p) == 3 ){	// .ne.jp 
					serverlast = p + 1;
					continue;
				}								// name.jp 
				serverlast = last + 1;
				break;
			}									// name.ne.jp
			break;
		}
		if ( serverlast != NULL ){
			*serverlast = '\0';
			strcpy(ri->mbox, p);
			ri->usembox = MBOX_INSERVER;
		}else{
			ri->check = FALSE;	// ołȂ̂łȏ㒲ׂȂ
			return;
		}
	}
	if ( ri->usembox != MBOX_UNKNOWN ){
		char *fromp, *byp;
								// for ȍ~͏O
		{
			char *fp = strstr( header, "for " );
			if ( fp ) *fp = '\0';
		}

		fromp = strstr(header, ri->mbox);
		byp = strstr(byptr, ri->mbox);
		if ( byp == NULL ){	// from ??? by !mbox
			if ( strstr(header, "unknown") ) return; // unknown͖
			if ( strstr(header, "unverified") ) return; // unknown͖
			if ( strstr(header, "localhost") ) return; // localhost͖
			if ( strstr(header, "127.0.0.1") ) return; // localhost͖
			ri->usembox = MBOX_UNKNOWN;	// mailbox ȊOoR
		}else if ( fromp == NULL ){	// from !mbox by mbox
			ri->usembox = MBOX_ENTER;	// mailbox MvmF
			if ( strstr(header, ".co.jp") ){
				ri->usembox = MBOX_UNKNOWN; // from  co.jp hCꉞM
			}
		} // mailbox oR
	}
}

// L[[h`FbN
void CheckKeyword(SPAMINFO *si, const char *header, const char *max)
{
	ACOFF asoffset;

	asoffset = AC_spams;
	if ( asoffset == 0 ) return;
	for(;;){
		AC_SPAM *as;
		size_t len;
		char buf[MAX_BUF];

		as = (AC_SPAM *)(cfgac.bottom + asoffset);
		len = strlen(cfgstr.bottom + as->header);
		if ( !memicmp(header, cfgstr.bottom + as->header, len) ){
			char *scanstr;

			GetInfo(buf, header + len, max);
			scanstr = cfgstr.bottom + as->keyword;

			while(*scanstr){
				if ( strstr(buf, scanstr) ){
					SetSpam(si, as->points, cfgstr.bottom + as->id);
				}
				scanstr += strlen(scanstr) + 1;
			}
		}
		if ( as->next == 0 ) break;
		asoffset = as->next;
	}
}

char *ParamLenFix(char *param, int len)
{
	char *ptr, *pmax;

	ptr = param;
	pmax = ptr + len - 3;

	#ifdef UNICODE
		while ( *ptr ){
			if ( ptr < pmax ){
				ptr++;
				continue;
			}else{
				strcpy(ptr, "...");
				break;
			}
		}
	#else
		while ( *ptr ){
			if ( ptr < pmax ){
				if ( IskanjiA(*ptr) ){
					if ( (BYTE)*(ptr + 1) <= ' ' ){
						*ptr = '\0';
						break;
					}else{
						ptr++;
					}
				}
				ptr++;
				continue;
			}else{
				strcpy(ptr, "...");
				break;
			}
		}
	#endif
	return param;
}

// [wb_
void CheckHeader(SSOCKET *ssock, AC_MAIL *mail, int mailID, int *spammail, char *text, char *textmax, BOOL unseen)
{
	SPAMINFO si;
	RECEIVEDINFO ri;
	char buf[MAX_BUF];
	char from[MAX_BUF];
	char to[MAX_BUF];
	char subject[MAX_BUF];
	char date[MAX_BUF];
	int encode = 7;
	CPESTRUCT cpes;
#ifdef UNICODE
	WCHAR bufW[MAX_BUF];
	WCHAR tempbuf[MAX_BUF];
#endif
	TCHAR *state;

	char *ptr;

	si.points = 0;
	si.full = FALSE;
	si.ID[0] = '\0';

	ri.count = 0;
	ri.check = TRUE;
	ri.usembox = MBOX_UNKNOWN;

	from[0] = '\0';
	to[0] = '\0';
	subject[0] = '\0';
	date[0] = '\0';

	for ( ptr = text ; ptr < textmax ; ptr += strlen(ptr) + 1 ){
		if ( *ptr == '\0' ){	// swb_I
			if ( encode != 7 ) break;
			ptr++;
			while ( ptr < textmax ){
				if ( (*ptr & B7) ){
					SetSpam(&si, X_spCode, "*code");
					break;
				}
				ptr++;
			}
			break;
		}
		if ( !Isalpha(*ptr) ) continue; // Os̑

		CheckKeyword(&si, ptr, textmax);	// spam L[[h`FbN

									// `ς݃`FbN
		if ( X_spDirect && !memicmp(ptr, "Received:", 9) ){
			if ( !ri.count ) ri.check = TRUE; // ߂ĂȂ`FbNJn
			if ( ri.check != FALSE ){
				buf[0] = '\0';
				GetInfo(buf, ptr + 9, textmax);
				CheckReceived(&ri, buf);
			}
			continue;
		}
		ri.check = FALSE;

		if ( !memicmp(ptr, "Content-Type:", 13) ){
			// ʂ EUC-JP  EUC ͎gȂ
			if ( strstr(ptr, "EUC\"") ) SetSpam(&si, X_spCtype, "*content");
			continue;
		}

		if ( !memicmp(ptr, "Content-Transfer-Encoding:", 26) ){
			// 7bit ȊOȂ body `FbN߂
			if ( strstr(ptr, "7bit") == NULL ) encode = 0;
			continue;
		}

		if ( !memicmp(ptr, "From:", 5) ){
			AddrCheck(&si, ptr + 5, textmax, from);
			continue;
		}
		if ( !memicmp(ptr, "To:", 3) ){
			AddrCheck(&si, ptr + 3, textmax, to);
			continue;
		}
		if ( !memicmp(ptr, "Subject:", 8) ){
			if ( GetInfo(subject, ptr + 8, textmax) || strchr(subject, '\x1b') ){
				SetSpam(&si, X_spSubj, "*SubjCode");
			}
			continue;
		}
		if ( !memicmp(ptr, "Date:", 5) ){
			GetInfo(date, ptr + 5, textmax);
			if ( strlen(date) > 60 ){
				date[60] = '\0';
				SetSpam(&si, X_spCode, "*date");
			}else{
				FixDate(date);
			}
			continue;
		}
	}
	if ( ri.usembox == MBOX_ENTER ) SetSpam(&si, X_spDirect, "*direct");
	if ( from[0] == '\0' )	SetSpam(&si, X_spNoFrom, "*noFrom");
	if ( to[0] == '\0' )	SetSpam(&si, X_spNoTo, "*noTo");
	if ( subject[0] == '\0' ) SetSpam(&si, X_spNoSubj, "*noSubj");
										// p[^p`
	{
		char *paramptr;
		paramptr = strchr(from, ',');
		if ( paramptr != NULL ) strcpy(paramptr, "...");
		paramptr = strchr(to, ',');
		if ( paramptr != NULL ) strcpy(paramptr, "...");
	}
	if ( X_spam && (si.points >= X_spampt) ){ // spam ̎ <> ȗ
		char *nameptr;

		nameptr = strchr(from, '<');
		if ( nameptr != NULL ){
			char *lastptr;

			nameptr++;
			lastptr = strchr(nameptr, '>');
			if ( lastptr != NULL ) *lastptr = '\0';
			strcpy(buf, nameptr);
			strcpy(from, buf);
		}
	}
	if ( mail == NULL ) return; // ُI΍A{NULLɂȂ͂Ȃ̂ŁAt߂ŔjNĂ͂

	wsprintfA(buf, "1%s" "\t2%d"
			"\t3%s" "\t4%s" "\t5%s"
			"\t6%s" "\t7%d" "\t8%s" "\t9%d",
			cfgstr.bottom + mail->id, mailID,
			ParamLenFix(from, 100), ParamLenFix(to, 100), date,
			ParamLenFix(subject, 200), si.points, si.ID, ri.count);
	cpes.id = (int)(AC_MAIL *)mail;
#ifdef UNICODE
	Utf8ToUnicode(buf, bufW, MAX_BUF);
	cpes.param = bufW;
	#define bufT bufW
#else
	cpes.param = buf;
	#define bufT buf
	#define tempbuf subject
#endif
	state = tempbuf;
#ifdef _WIN64
	if ( unseen ) *state++ = L'';
#else
	if ( unseen ){
		if ( user_lang == LCID_JAPANESE ){
			*state++ = '\x81'; // 
			*state++ = '\x9c';
		}else{
			*state++ = '*';
		}
	}
#endif
									// j[p񐶐EActions
	if ( X_spam && (si.points >= X_spampt) ){
		(*spammail)++;
		cpes.ac = NULL;
		if ( (ssock != NULL) && (X_sdelpt > 0) && (si.points >= X_sdelpt) ){
			if ( X_sdelbk ) DumpMail(buf, text, textmax, mailID);
			wsprintfA(subject, "DELE %d", mailID);
			wsPuts(ssock, subject);
			wsGets(ssock, subject);
			wsprintfA(buf + strlen(buf), "\t0%s", subject);
			cpes.ac = (ACTIONS *)(cfgac.bottom + Z_[zDelMail]);
			SendMessage(hMainWnd, WM_CP_EXECACTION, 0, (LPARAM)&cpes);
		}

		tsprintf(state, GetCfgDefStr(X_spaminfo, T("spam(%7points %8%9)")), bufT);
	}else{
		tsprintf(state, GetCfgDefStr(X_minfo, T("%3{%5}%6")), bufT);
	}


	ThAddString(&mail->list, tempbuf);
	if ( cpes.ac != NULL ) return;
	cpes.ac = (ACTIONS *)(cfgac.bottom + Z_[zRecvMail]);

	SendMessage(hMainWnd, WM_CP_EXECACTION, 0, (LPARAM)&cpes);
}

const char *MailUserName(AC_MAIL *mail, char *buf2)
{
	char *proxy;
	char *username = cfgstr.bottom + mail->user;

	proxy = strchr(username, '%');
	if ( proxy == NULL ) return username;
	strcpy(buf2, username);
	*(buf2 + (proxy - username)) = '\0';
	return buf2;
}

#if 0
#define IMAP4LOG(text) LogWrite(0x84, text)
#else
#define IMAP4LOG(text)
#endif

BOOL GetImap4Response(SSOCKET *ssock, char *buf)
{
	for (;;){
		if ( wsGets(ssock, buf) == FALSE ) return FALSE;
		IMAP4LOG(buf);
		if ( buf[0] != '*' ) break;
	}
	if ( memcmp(buf, "0 OK", 4) != 0 ) return FALSE;
	return TRUE;
}

int LoginImap4(SSOCKET *ssock, AC_MAIL *mail)
{
	char buf[MAX_BUF];
	char buf2[MAX_BUF];

	if ( wsGets(ssock, buf) == FALSE ) return MAILERR_CONNECT;
	IMAP4LOG(buf);
	if ( memcmp(buf, "* OK", 4) != 0 ) return MAILERR_CONNECT;
#if 0
	wsPuts(ssock, "0 AUTHENTICATE CRAM-MD5\r\n");
	IMAP4LOG("0 AUTHENTICATE CRAM-MD5\r\n");

	buf[0] = '\0';
	GetImap4Response(ssock, buf);
	if ( memcmp(buf, "+ ", 2) == 0 ){
		char text[MAX_BUF], *dest, *ptr, *pmax;

		// challengetext 𓾂
		ptr = buf + 2;
		pmax = ptr + strlen(ptr);
		dest = text;
		while ( ptr < pmax ){
			int len;

			len = B64DecodeBytes(&ptr, dest);
			if ( len == 0 ) break;
			dest += len;
		}
		*dest = '\0';
		IMAP4LOG(text);
		// digest 𓾂
		wsprintfA(buf, "%s%s", text, cfgstr.bottom + mail->pwd);
		IMAP4LOG(buf);
		MDString(buf);
		IMAP4LOG(buf);
		// M쐬
		wsprintfA(text, "%s %s", MailUserName(mail, buf2), buf);
		IMAP4LOG(text);
			// mine encode          xxxxxxxxxxx= 

		IMAP4LOG(buf);
		wsPuts(ssock, buf);

		for (;;){
			wsGets(&ssock, buf);
			IMAP4LOG(buf);
			if ( buf[0] != '*' ) break;
		}
		if ( memcmp(buf, "OK", 4) == 0 )
	}
#endif
	wsprintfA(buf, "0 LOGIN %s %s",
			MailUserName(mail, buf2), cfgstr.bottom + mail->pwd);
	wsPuts(ssock, buf);
	IMAP4LOG("login");
	if ( GetImap4Response(ssock, buf) != FALSE ) return 0;
	return MAILERR_GENERIC;
}

int ReadMailBoxImap4(SSOCKET *ssock, AC_MAIL *mail)
{
	int status = MAILERR_GENERIC;
	char UIDbuf[MAX_BUF], *UIDptr = UIDbuf;
	char buf[MAX_BUF];
	int spam = 0, listcount = 0;
	const char *boxname;
	DWORD mailfirst, mailend;

	// IMAP4 UTF7 ̕ӂ܂ĂȂ
	boxname = (*(cfgstr.bottom + mail->mailbox) == '\0') ?
			"INBOX" : (cfgstr.bottom + mail->mailbox);

							// ǂ擾
	wsprintfA(buf, "1 STATUS \"%s\" (UNSEEN)", boxname);

	wsPuts(ssock, buf);
	IMAP4LOG(buf);
	IMAP4LOG("\r\n");
	mail->unseen = 0;
	for (;;){
		const char *ptr;

		if ( wsGets(ssock, buf) == FALSE ) return MAILERR_GENERIC;
		IMAP4LOG(buf);
		if ( buf[0] != '*' ) break;

		ptr = strstr(buf, "(UNSEEN ");
		if ( ptr != NULL ){
			ptr += 8;
			mail->unseen = GetNumberA(&ptr);
		}
	}
	if ( memcmp(buf, "1 OK", 4) != 0 ) return status;

							// ǂݍݐp INBOX JAS擾
	wsprintfA(buf, "1 EXAMINE \"%s\"", boxname);
	wsPuts(ssock, buf);
	IMAP4LOG(buf);
	IMAP4LOG("\r\n");
	for (;;){
		const char *ptr;

		if ( wsGets(ssock, buf) == FALSE ) return MAILERR_GENERIC;
		IMAP4LOG(buf);
		if ( buf[0] != '*' ) break;

		ptr = buf + 2;
		if ( Isdigit(*ptr) ){
			int num;

			num = GetNumberA(&ptr);
			if ( strcmp(ptr, " EXISTS") == 0 ){
				status = num;
				mail->allcount = num;
				IMAP4LOG("1 Get status exists\r\n");
				mail->spams = 0;
				ThFree(&mail->list);
			}
/*
			}else if ( strcmp(ptr, " RECENT") == 0 ){
				mail->recent = num;
				IMAP4LOG("1 Get status recent\r\n");
			}
*/
		}
	}
	if ( memcmp(buf, "1 OK", 4) != 0 ) return status;

							// 擾郁[UID
	if ( mail->allcount == 0 ) return 0;

	mailend = mail->allcount;
	mailfirst = mailend - X_mheader + 1;
	if ( mailfirst < 1 ) mailfirst = 1;

	wsprintfA(buf, "2 UID SEARCH UNDELETED %d:%d", mailfirst, mailend);
	wsPuts(ssock, buf);

	for (;;){
		wsGets(ssock, buf);
		IMAP4LOG(buf);
		if ( buf[0] != '*' ) break;
		if ( memcmp(buf + 1, " SEARCH ", 8) == 0 ){
			size_t len;

			len = strlen(buf);
			if ( ((UIDbuf - UIDptr) + len) < (MAX_BUF - 1) ){
				strcpy(UIDptr, buf + 8);
				UIDptr += strlen(UIDptr);
			}
			listcount++;
		}
	}
	if ( memcmp(buf, "2 OK", 4) != 0 ) return status;

	// undeletd ̐ all ̐̐
	if ( (mail->allcount < X_mheader) && (mail->allcount > listcount) ) mail->allcount = listcount;

							// e[擾
	if ( UIDptr != UIDbuf ){
		char text[0x8000], *p, *pmax;
		char UID[MAX_BUF];
		const char *ptr;
		int mailid = status;
		BOOL unseen;

		if ( mailid > X_mheader ) mailid = X_mheader;
		ptr = UIDbuf;
		while( GetLineParamA(&ptr, UID) != '\0' ){
			unseen = FALSE;
			wsprintfA(buf, "3 UID FETCH %s FLAGS", UID);
			IMAP4LOG(buf);
			wsPuts(ssock, buf);

			for (;;){
				if ( MailCheckBreak ) break;
				if ( wsGets(ssock, buf) == FALSE ) break;
				IMAP4LOG(buf);
				if ( buf[0] == '*' ){
					if ( strstr(buf + 1, "\\Seen") == NULL ) unseen = TRUE;
				}
				if ( memcmp(buf, "3 ", 2) == 0 ) break;
			}

			wsprintfA(buf, "3 UID FETCH %s (RFC822.HEADER)", UID);
			IMAP4LOG(buf);
			wsPuts(ssock, buf);

			p = text;
			pmax = p + 0x8000 - MAX_BUF;
			*p = '\0';

			for (;;){
				if ( MailCheckBreak ) break;
				if ( wsGets(ssock, p) == FALSE ) break;
				IMAP4LOG(p);
				if ( p[0] == '*' ) continue;
				if ( memcmp(p, "3 ", 2) == 0 ) break;
				if ( p > pmax ) *p = '\0'; // zƂ͎cXLbv
				p += strlen(p) + 1;
			}
			if ( memcmp(p, "3 OK", 4) != 0 ) break;

			*p++ = '\0';
			*p = '\0';
			CheckHeader(NULL, mail, mailid, &spam, text, p, unseen);
			mailid--;
		}
	}

	status -= spam;
	mail->spams = spam;
	return status;
}

BOOL GetPop3Response(SSOCKET *ssock, char *str)
{
	if ( wsGets(ssock, str) == FALSE ) return FALSE;
	if ( str[0] !='+' ) return FALSE;
	return TRUE;
}

int LoginPop3(SSOCKET *ssock, AC_MAIL *mail)
{
	char buf[MAX_BUF];
	char buf2[MAX_BUF];

	if ( GetPop3Response(ssock, buf) == FALSE ) return MAILERR_GENERIC;
	if ( MailCheckBreak ) return MAILERR_GENERIC;

	if ( mail->flags & ACMAIL_USEAPOP ){
		char timestamp[MAX_BUF], *p, *q;

		p = strchr(buf, '<');
		if ( p == NULL ) return MAILERR_GENERIC;
		q = strchr(p, '>');
		if ( q == NULL ) return MAILERR_GENERIC;
		*(q + 1) = '\0';
		strcpy(timestamp, p);
		strcat(timestamp, cfgstr.bottom + mail->pwd);
		MDString(timestamp);
		wsprintfA(buf, "APOP %s %s", MailUserName(mail, buf2), timestamp);
	}else{
		strcpy(buf, "USER ");
		strcat(buf, MailUserName(mail, buf2));
		wsPuts(ssock, buf);
		if ( GetPop3Response(ssock, buf) == FALSE ) return MAILERR_GENERIC;
		strcpy(buf, "PASS ");
		strcat(buf, cfgstr.bottom + mail->pwd);
	}
	if ( MailCheckBreak ) return MAILERR_GENERIC;
	wsPuts(ssock, buf);
	if ( GetPop3Response(ssock, buf) == FALSE ) return MAILERR_PASSWORD;
	return 0;
}

// 擾 & tB^ C
BOOL GetHeaderFromPop3(SSOCKET *ssock, AC_MAIL *mail, int mailID, int *spammail)
{
	char text[0x8000], *p, *maxptr;
	char buf[MAX_BUF];
										// [wb_M
								// Mv
	wsprintfA(buf, "TOP %d %d", mailID, max(X_sdelbk, 10));
	wsPuts(ssock, buf);
	if ( !wsGets(ssock, buf) ) return FALSE;
	if ( buf[0] == '-' ){
		wsprintfA(buf, "RETR %d", mailID);
		wsPuts(ssock, buf);
		if ( !wsGets(ssock, buf) ) return FALSE;
	}
	if ( buf[0] != '+' ) return FALSE;
								// M
	p = text;
	maxptr = p + 0x8000 - MAX_BUF;
	for(;;){
		if ( MailCheckBreak ) return FALSE;
		if ( !wsGets(ssock, p) ) return FALSE;
		if ( (*p == '.') && (*(p+1) == '\0') ) break;
		if ( p > maxptr ) *p = '\0'; // zƂ͎cXLbv
		p += strlen(p) + 1;
	}
	*p++ = '\0';
	maxptr = p;
	*p = '\0';

	CheckHeader(ssock, mail, mailID, spammail, text, maxptr, FALSE);
	return TRUE;
}

//------------------------------------- M[߂
int MailCheckMain(AC_MAIL *mail)
{
	SSOCKET ssock;
	impADDRINFO ai_default, *adr_info = NULL, *useadr;
	WSADATA wsad;
	SSL_CTX *ctx;

	char *domain;
	char buf[MAX_BUF];
	const char *p;
	int status = MAILERR_GENERIC;

#ifdef _WIN64
	#define reqwsver 0x202 // K2.2
#else
	WORD reqwsver;
#endif

	if ( hWSOCK32 == NULL ){ // WinSock API ̓ǂݍ
#ifdef _WIN64
		hWSOCK32 = LoadWinAPI("WS2_32.dll", NULL, WSOCK32DLL);
#else
		hWSOCK32 = LoadWinAPI((OSver.dwMajorVersion >= 5) ? "WS2_32.dll" : "WSOCK32.DLL", NULL, WSOCK32DLL);
#endif
		if ( hWSOCK32 == NULL ) return MAILERR_LOADDLL;
		GETDLLPROC(hWSOCK32, getaddrinfo);
		GETDLLPROC(hWSOCK32, freeaddrinfo);
	}
	if ( mail->flags & ACMAIL_USESSL ){ // SSL API ̓ǂݍ
		if ( hSsleay32 == NULL ){
			hSsleay32 = LoadLibrary(GetCfgDefStr(X_libssl, T("libssl.dll")));
			if ( hSsleay32 == NULL ) hSsleay32 = LoadLibrary(T("SSLEAY32.DLL"));
			if ( hSsleay32 != NULL ){
				if ( LoadWinAPI(NULL, hSsleay32, SSLEAY32DLL) == NULL ){
					FreeLibrary(hSsleay32);
					hSsleay32 = NULL;
				}
			}
			if ( hSsleay32 == NULL ) return MAILERR_NOSSL;

			GETDLLPROC(hSsleay32, OPENSSL_init_ssl);
			if ( DOPENSSL_init_ssl != NULL ){ // 1.01 ȍ~
//				MessageA("1.01");
				OPTS_VALUE opt_init = OPTS_VALUE_INIT;
				OPTS_VALUE opt_load = OPTS_VALUE_LOAD;
				GETDLLPROC(hSsleay32, TLS_client_method);

				DOPENSSL_init_ssl(opt_init, NULL); // SSL_library_init
				DOPENSSL_init_ssl(opt_load, NULL); // SSL_load_error_strings
			}else{
//				MessageA("1.00");
				GETDLLPROC(hSsleay32, SSL_library_init);
				GETDLLPROC(hSsleay32, SSL_load_error_strings);
				DTLS_client_method = (impTLS_client_method)GetProcAddress(hSsleay32, "SSLv23_client_method");
//				GETDLLPROC(hSsleay32, SSLv23_client_method);
				if ( DTLS_client_method == NULL ){
					FreeLibrary(hSsleay32);
					hSsleay32 = NULL;
					return MAILERR_NOSSL;
				}
				DSSL_library_init();
				DSSL_load_error_strings();
			}
		}
		//	RAND_seed(seed, sizeof(seed) - 1);
		//	SSLeay_add_ssl_algorithms();
		ctx = DSSL_CTX_new(DTLS_client_method());
		DSSL_CTX_set_mode(ctx, SSL_MODE_AUTO_RETRY);
	}

#ifndef _WIN64
	if ( OSver.dwMajorVersion >= 5 ){
		reqwsver = 0x202; // 2000ȍ~2.2
	}else{
		reqwsver = 0x101; // NT/9xȑO1.1
	}
#endif
	if ( DWSAStartup(reqwsver, &wsad) != 0 ) return MAILERR_WSOCK;

	memset(&ai_default, 0, sizeof(ai_default));
	ai_default.ai_socktype = SOCK_STREAM;
	domain = cfgstr.bottom + mail->ip;
	ssock.ssl = NULL;
	ssock.sock = INVALID_SOCKET;
	if ( Dgetaddrinfo == NULL ){ // Â`
		DWORD ip;
		SOCKADDR_IN addr_in;

		useadr = &ai_default;
		addr_in.sin_family = AF_INET;
		addr_in.sin_port = Dhtons((u_short)mail->port);	//|[g̎w
		ai_default.ai_addrlen = sizeof(addr_in);
		ai_default.ai_addr = (struct sockaddr *)&addr_in;
									//hbg`̃AhXIPAhX֕ϊ
		ip = Dinet_addr(domain);
		if ( ip == INADDR_NONE ){ //hbg`łȂƂ
			struct hostent *pHost;

			pHost = Dgethostbyname(domain);//zXg->IPAhXϊ
			if ( pHost != NULL ) ip = *((DWORD*)(pHost->h_addr));
		}
		if ( ip != INADDR_NONE ){
			addr_in.sin_addr.s_addr = ip;
			ssock.sock = Dsocket(PF_INET, SOCK_STREAM, 0);
		}
	}else{ // IPv6Ή
		wsprintfA(buf, "%d", mail->port);
		ai_default.ai_family = PF_UNSPEC;
		if ( Dgetaddrinfo(domain, buf, &ai_default, &adr_info) == 0 ){
			for ( useadr = adr_info ; useadr != NULL ; useadr = useadr->ai_next ){
				ssock.sock = Dsocket(useadr->ai_family, useadr->ai_socktype, useadr->ai_protocol);
				if ( ssock.sock != INVALID_SOCKET ) break;
			}
		}
	}

	if ( ssock.sock != INVALID_SOCKET ) for(;;){
		if ( MailCheckBreak ) break;
													//ڑ
		if ( Dconnect(ssock.sock, useadr->ai_addr, (DWORD)useadr->ai_addrlen) ){
			status = MAILERR_CONNECT;
			break;
		}
/*
		{
			char *proxydom;
			proxydom = strchr(cfgstr.bottom + mail->user, '%');
			if ( proxydom != NULL ) ConnectProxy(&ssock, proxydom);
		}
*/
		if ( mail->flags & ACMAIL_USESSL ){
			ssock.ssl = DSSL_new(ctx);
			DSSL_set_fd(ssock.ssl, (int)ssock.sock);	// !x64! ssock.sock Ōx
			DSSL_connect(ssock.ssl);
		}
		if ( mail->flags & ACMAIL_USEIMAP ){ // IMAP4
			status = LoginImap4(&ssock, mail);
			if ( status >= 0 ){
				status = ReadMailBoxImap4(&ssock, mail);
				if ( status >= 0 ) mail->last = ltime;
				wsPuts(&ssock, "9 LOGOUT");
				IMAP4LOG("9 LOGOUT");
			}
		}else{ // POP3
			int spam = 0;
			status = LoginPop3(&ssock, mail);
			if ( status < 0 ) break;

			if ( MailCheckBreak ) break;
			wsPuts(&ssock, "STAT");
			if ( GetPop3Response(&ssock, buf) == FALSE ) break;
			p = buf + 4;
			status = GetNumberA(&p);

			mail->unseen = status - mail->allcount;
			if ( mail->unseen < 0 ) mail->unseen = 0;

			ThFree(&mail->list);
			if ( status > 0 ){
				int mailid;

				mailid = status;
				for(;;){
					if ( mailid < 1 ) break;
					if ( mailid <= (status - (X_mheader + spam)) ) break;
					if ( GetHeaderFromPop3(&ssock, mail, mailid, &spam) == FALSE ) break;
					mailid--;
				}
				status -= spam;
			}
			mail->spams = spam;
			mail->last = ltime;

			wsPuts(&ssock, "QUIT");
			GetPop3Response(&ssock, buf);
		}
		if ( ssock.ssl != NULL ){
			DSSL_shutdown(ssock.ssl);
			DSSL_free(ssock.ssl);
			DSSL_CTX_free(ctx);
		}
		Dshutdown(ssock.sock, 2);	// send & recv 𖳌
		break;
	}
	Dclosesocket(ssock.sock);
	if ( adr_info != NULL ) Dfreeaddrinfo(adr_info);
	DWSACleanup();
	return status;
}
/*-----------------------------------------------------------------------------
	[`FbN
-----------------------------------------------------------------------------*/
void MailCheck(AC_MAIL *mail, int flag)
{
	CPESTRUCT cpes;
	int status;
	TCHAR param[MAX_PATH];

	status = MailCheckMain(mail);
	mail->i.lasttick = TimerNowTick;

	if ( status < 0 ){
		if ( status < MAILERR_MAX ) status = MAILERR_GENERIC;
		cpes.ac = (ACTIONS *)(cfgac.bottom + Z_[zError]);
		cpes.id = zError;
		cpes.param = Errors[MAILERR_GENERIC - status];
		SendMessage(hMainWnd, WM_CP_EXECACTION, 0, (LPARAM)&cpes);
	}else{
		ACOFF offset;

		// %1:O %2:[ %3:
		wsprintf(param, T("1%s\t2%d\t3%d"), GetCfgStr(mail->id), mail->allcount, mail->unseen);

		if ( flag & ACMC_USEZMAIL ){
			offset = Z_[zMailInfo];
		}else{
			if ( mail->flags & ACMAIL_RELCHECK ){
				offset = Z_[(mail->unseen > 0) ? zNewMail : zNoMail];
			}else{
				offset = Z_[(mail->allcount > 0) ? zNewMail : zNoMail];
			}
		}
		if ( offset ){
			cpes.ac = (ACTIONS *)(cfgac.bottom + offset);
			cpes.id = (int)(AC_MAIL *)mail;
			cpes.param = param;
			SendMessage(hMainWnd, WM_CP_EXECACTION, 0, (LPARAM)&cpes);
		}
	}
}

//------------------------------------- SẴ[`FbN
DWORD WINAPI MailCheckAllThread(int flag)
{
	AC_MAIL *acm;
	BOOL checkloop = TRUE;

	while( checkloop ){
		checkloop = FALSE;
		for ( MailReadOffset = AC_mails ; MailReadOffset ; MailReadOffset = acm->next ){
			acm = (AC_MAIL *)(cfgac.bottom + MailReadOffset);
			if ( acm->check != FALSE ){
				if ( MailCheckBreak ){
					checkloop = FALSE;
					break;
				}
				MailCheck(acm, flag);
				acm->check = FALSE;
				checkloop = TRUE;
			}
		}
	}
	if ( hSsleay32 != NULL ){
		FreeLibrary(hSsleay32);
		hSsleay32 = NULL;
	}
	if ( hWSOCK32 != NULL ){
		FreeLibrary(hWSOCK32);
		hWSOCK32 = NULL;
	}
	if ( hMailThread != NULL ){
		CloseHandle(hMailThread);
		hMailThread = NULL;
	}
	if ( MailCheckBreak > MAILCHECK_OFF ) MailCheckBreak = 0;
	return 0;
}

void StartMailCheck(int flag, int id)
{
	DWORD tmp;

	ACOFF offset;
	AC_MAIL *acm;
	BOOL check = FALSE;

	offset = AC_mails;
	for ( ; offset ; offset = acm->next, id-- ){
		acm = (AC_MAIL *)(cfgac.bottom + offset);
		if ( id > 0 ) continue;
		if ( (flag & ACMC_BOOT) && !(acm->flags & ACMAIL_BOOTCHECK) ){
			continue;
		}
		if ( (flag & ACMC_CONNECT) && !(acm->flags & ACMAIL_CONNECTCHECK) ){
			continue;
		}
		if ( (flag & ACMC_TIMER) && !CheckInterval(&acm->i) ) continue;
		check = TRUE;
		acm->check = TRUE;
		if ( !id ) break;
	}
	if ( check == FALSE ) return;
	if ( OSver.dwPlatformId != VER_PLATFORM_WIN32_NT ){
		MailCheckAllThread(flag);
		return;
	}
	if ( hMailThread != NULL ) return;
	hMailThread = CreateThread(NULL, 0,
			(LPTHREAD_START_ROUTINE)MailCheckAllThread,
			(void *)(int)flag, 0, &tmp);
}
