/*-----------------------------------------------------------------------------
	ClockPod / C^[o^C}								(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "CLOCKPOD.H"

DefineWinAPI(HWND, ImmGetDefaultIMEWnd, (HWND)) = NULL;

const char NullWave[] = {	//  wave data
 0x52, 0x49, 0x46, 0x46, 0x32, 0x00, 0x00, 0x00,
 0x57, 0x41, 0x56, 0x45, 0x66, 0x6D, 0x74, 0x20,
 0x12, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00,
 0x40, 0x1F, 0x00, 0x00, 0x40, 0x1F, 0x00, 0x00,
 0x01, 0x00, 0x08, 0x00, 0x00, 0x00, 0x66, 0x61,
 0x63, 0x74, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x64, 0x61, 0x74, 0x61, 0x00, 0x00,
 0x00, 0x00
};

#define receivesize 0x1000
void ReceiveMessenger(DWORD mailsize)
{
	TCHAR *maxptr, *revname, *mes;
	TCHAR Status[receivesize];
	DWORD tmp;

	if ( mailsize >= receivesize ){
		mailsize = receivesize - 1;
	}
	#ifdef UNICODE
	{
		char StatusA[receivesize];

		if ( ReadFile(hMessenger, StatusA, mailsize, &tmp, NULL) == FALSE ) return;
		tmp = MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, StatusA, tmp, Status, receivesize);
	}
	#else
		if ( ReadFile(hMessenger, Status, mailsize, &tmp, NULL) == FALSE ) return;
	#endif
	Status[tmp] = '\0';

	maxptr = Status + mailsize - 1;
	if ( mailsize && !*maxptr ){
		revname = Status + tstrlen(Status) + 1;
		if ( revname < maxptr ){
			mes = revname + tstrlen(revname) + 1;
			if ( mes < maxptr ){
				TCHAR buf[receivesize];

				wsprintf(buf, T("1%s\t2%s\t3%s"), Status, revname, mes);
				Z_ExecAction(zMessenger, buf);
			}
		}
	}
}

void CustomizeWait(void)
{
	HANDLE hFile;
	WIN32_FIND_DATA ff;

	if ( WaitForSingleObject( Cfgedit.pi.hProcess, 0) != WAIT_OBJECT_0 ) return;

	CloseHandle(Cfgedit.pi.hProcess);
	CloseHandle(Cfgedit.pi.hThread);

	Cfgedit.edit = FALSE;
										// t@CXVĂ邩mF
	hFile = FindFirstFile(cfgfile, &ff);
	if ( hFile == INVALID_HANDLE_VALUE ) return;
	FindClose(hFile);
	if ( memcmp( &ff.ftLastWriteTime, &Cfgedit.ConfigStamp, sizeof(FILETIME)) ){
		Customize(0);
		NextMail = 2;
	}
}

void IMECheck(void)
{
	DWORD i;
	static DWORD OldIMEStatus = FALSE;

	if ( hIMM32 == NULL ){
		hIMM32 = LoadLibraryA("IMM32.DLL");
		if ( hIMM32 != NULL ){
			GETDLLPROC(hIMM32, ImmGetDefaultIMEWnd);
		}
	}
	if ( hIMM32 == NULL ) return;
	if ( SendMessageTimeout(DImmGetDefaultIMEWnd(ahWnd), WM_IME_CONTROL,
					IMC_GETOPENSTATUS, 0, SMTO_ABORTIFHUNG | SMTO_BLOCK,
					100, (DWORD_PTR *)&i) == FALSE ){
		return;
	}
	if ( i == OldIMEStatus ) return;
	OldIMEStatus = i;

	if ( i == FALSE ){
		tstrcpy(IMEstatus, T(" off"));
	}else{
		tstrcpy(IMEstatus, T(" R"));
	}
	Z_ExecAction(zIME, NULL);
}

#pragma argsused
void CALLBACK TimerProc(HWND hWnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
	static WORD OSec = 99, OMin = 99, OHour = 99;
	static DWORD wavewait = 10;
	HWND nhWnd;
	RECT nRect;
	POINT pos;

	DWORD mailsize, mails, tmp;
	TCHAR Status[0x1000];
	UnUsedParam(uMsg);UnUsedParam(idEvent);UnUsedParam(dwTime);

	TimerNowTick = GetTickCount();

	if ( NearPointer ){
		GetCursorPos(&pos);
		if ( (pos.x < DPos.x) || (pos.x > (DPos.x + WindowSize.cx * 2)) ||
			 (pos.y < DPos.y) || (pos.y > (DPos.y + WindowSize.cy)) ){
			NearPointer = FALSE;
		}
	}

	if ( X_IME ){
		if ( X_IME == 1 ) IMECheck();
		if ( ChangeIMEwnd != HWND_BROADCAST ){ // IME ؂ւmFEĎs
			if ( TimerNowTick > ChangeIMElasttick ){
				ChangeIMEwnd = HWND_BROADCAST; // mFI
//				LogWrite(999, T("retry IMEsetting ... fault"));
			}else{
				if ( TimerNowTick >= ChangeIMEtick ){ // Ďs
//					LogWrite(999, T("retry IMEsetting ... retry"));
					PostMessage(ChangeIMEwnd, WM_CLOCKPOD, IMECHANGESTATUSCMD, ChangeIMEmode);
					ChangeIMEtick = TimerNowTick + 100;
				}
			}
		}else{
/*
			if ( (ahWnd == NowIMEwnd) && (IMEwndCapLen != aWndLen) ){
				SetIMEsetting(NowIMEwnd, IMEstat);
			}
*/
		}
	}

	{
		ACTIONS *ac;
		struct EVENTLOGLIST *el;

		ac = (ACTIONS *)(cfgac.bottom + Z_[zEventLog]);
		if ( (ac != NULL) && (ac->type != AC_null) ){
			if ( (ac->type == AC_message) && (ac->next == 0) &&
				*ThTOFFSETSTR(&cfgstr, ((AC_MESSAGE *)ac)->message) == '\0' ){
			}else{
				for ( el = ELogList ; el->name != NULL ; el++ ){
					if ( el->hLog != NULL ){
						DWORD count;
						if ( GetNumberOfEventLogRecords(el->hLog, &count) != FALSE ){
							if ( count != el->count ){
								el->count = count;
								wsprintf(Status, T("1%s"), el->name);
								Z_ExecAction(zEventLog, Status);
							}
						}
					}
				}
			}
		}
	}
											// JX^}CYJn҂ -----------
	if ( Cfgedit.edit ) CustomizeWait();
											// ҂ -------------------
	if ( wavewait ){
		wavewait--;
	}else{
		if ( WaveStacks ){
			if ( tPlaySoundMain(WaveStack[0].name, WaveStack[0].flag) != FALSE ){
												// ɎԂ|邽
				wavewait = 400 / INTERVAL + 1;	// 400ms A҂s
				WaveStacks--;
				memmove(&WaveStack[0], &WaveStack[1],
							WaveStacks * sizeof(WAVESTACK));
			}
		}else while ( ChangingVolume != FALSE ){
			if ( !sndPlaySound((const TCHAR *)NullWave, SND_ASYNC | SND_MEMORY | SND_NOSTOP)){
				if ( !GetLastError() ) break; // ܂Đ
			}
			waveOutSetVolume(0, OldVolume);
			ChangingVolume = FALSE;
			break;
		}
	}
											// PodMailSlot  ---------------
	if ( hPodSlot && GetMailslotInfo(hPodSlot, NULL, &mailsize, &mails, NULL) ){
		if ( mails && (mailsize != MAILSLOT_NO_MESSAGE) ){
		if ( mailsize >= (TSIZEOF(Status) - 1) ) mailsize = TSIZEOF(Status) - 2;
		#ifdef UNICODE
		{
			char StatusA[TSIZEOF(Status)];

			if ( ReadFile(hPodSlot, StatusA, mailsize, &tmp, NULL) ){
				StatusA[tmp] = '\0';
				if ( memcmp(StatusA, UTF8HEADER, UTF8HEADERSIZE) == 0 ){
					Utf8ToUnicode(StatusA + UTF8HEADERSIZE, Status + 1, TSIZEOF(Status));
				}else{
					AnsiToUnicode(StatusA, Status + 1, TSIZEOF(Status));
				}
				Status[0] = '1';
				PodMail(Status, tmp);
			}
		}
		#else
			if ( ReadFile(hPodSlot, Status + 1, mailsize, &tmp, NULL) ){
				Status[tmp + 1] = '\0';
				if ( memcmp(Status + 1, UTF8HEADER, UTF8HEADERSIZE) == 0 ){
					WCHAR StatusW[TSIZEOF(Status)];
					Utf8ToUnicode(Status + 1 + UTF8HEADERSIZE, StatusW, TSIZEOF(StatusW));
					UnicodeToAnsi(StatusW, Status + 1, TSIZEOF(Status));
				}
				Status[0] = '1';
				PodMail(Status, tmp);
			}
		#endif
		}
	}
											// Messenger  -----------------
	if ( hMessenger && GetMailslotInfo(hMessenger, NULL, &mailsize, &mails, NULL) ){
		if ( mails && (mailsize != MAILSLOT_NO_MESSAGE)){
			ReceiveMessenger(mailsize);
		}
	}
											// v -----------------------
	GetLocalTime(&ltime);
	if ( OSec != ltime.wSecond ){
		OSec = ltime.wSecond;
					// eLXg̒擾
					// UNICODE wgƂŁAPɃJEg
					// (ȈՃv|[Vi(^^;)
		aWndLen = 0;
		SendMessageTimeoutW(ahWnd, WM_GETTEXTLENGTH, 0, 0,
				SMTO_ABORTIFHUNG | SMTO_BLOCK, 100, (DWORD_PTR *)&aWndLen);

		SetTime();
		RasCheckMain();
		Z_ExecAction(zEveryS, NULL);

		if ( X_transpar == 0 ){
			BOOL NewNoTranspar;

			GetCursorPos(&pos);
			if ( ((DWORD)(pos.x - DPos.x) < (DWORD)WindowSize.cx) &&
				 ((DWORD)(pos.y - DPos.y) < (DWORD)WindowSize.cy) ){
				NewNoTranspar = TRUE;
			}else{
				NewNoTranspar = FALSE;
			}
			if ( NewNoTranspar != NoTranspar ){
				NoTranspar = NewNoTranspar;
				ForceDraw = TRUE;
			}
		}

		if ( OMin != ltime.wMinute ){
			OMin = ltime.wMinute;
			Z_ExecAction(zEveryM, NULL);
			StartMailCheck(B1, -1);
			if ( OHour != ltime.wHour ){
				OHour = ltime.wHour;
				Z_ExecAction(zEveryH, NULL);
			}
		}
	}
	if ( MouseStatus == MS_NORMAL ){		// ANeBuEBhEo -------
		nhWnd = GetPWindow();
		if ( ahWnd != nhWnd ){
			ahWnd = nhWnd;
			GetWndStyle();

			ChangeIMEwnd = HWND_BROADCAST;
		}
											// ANeBuύX
		if ( GetForegroundWindow() == hWnd ) SetForegroundWindow(ahWnd);

											// ANeBuEBhEWo ---
		GetWindowRect(ahWnd, &nRect); // Win95  FALSE (^^;
		if ( memcmp(&aRect, &nRect, sizeof(aRect)) ){
			aRect = nRect;

			if ( DMonitorFromWindow != NULL ){
				HMONITOR hMonitor;
				MONITORINFO MonitorInfo;

				hMonitor = DMonitorFromWindow(ahWnd, MONITOR_DEFAULTTONEAREST);
				MonitorInfo.cbSize = sizeof(MonitorInfo);
				DGetMonitorInfo(hMonitor, &MonitorInfo);
				sRect = MonitorInfo.rcWork;
			}
			MoveClock(hWnd);
		}
		pos.x = DPos.x + WindowSize.cx / 2;
		pos.y = DPos.y + WindowSize.cy / 2;
		nhWnd = WindowFromPoint(pos);
											// ^XNo[dȂĂ邩 -----
		if ( bhWnd != NULL ){
			GetWindowRect(bhWnd, &nRect); // Win95  FALSE (^^;
			if ( PtInRect(&nRect, pos) == FALSE ){	// dȂĂȂ
				if ( nhWnd != hWnd ){		// ̏ɃEBhEƂ
					MoveClock(hWnd);
				}
				if ( LappedTaskBar ){		// ܂ŉBĂƂ
					LappedTaskBar = FALSE;
					MoveClock(hWnd);
				}
			}else{					// dȂ
				if ( !LappedTaskBar ){
					LappedTaskBar = TRUE;
					MoveClock(hWnd);
				}
			}
		}else{
			if ( LappedTaskBar ){			// ܂ŉBĂƂ
				LappedTaskBar = FALSE;
				MoveClock(hWnd);
			}
		}
	}
	if ( DispMesRate == 0 ){	// ebv(ꊇ) -----
		if ( DispMesStock && (MouseStatus != MS_STOPTELOP)){
			DispMesX -= (FontSize.x * X_telopsp) / ((10 * 1000) /INTERVAL) + 1;
			ForceDraw = TRUE;
		}
	}
	if ( ForceDraw != FALSE ){
		if ( X_telopx ) SetTime();
		DrawWindow(hWnd);
		ForceDraw = FALSE;
	}
}
												// ebv() -----
#pragma argsused
void CALLBACK TelopTimerProc(HWND hWnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
	UnUsedParam(uMsg);UnUsedParam(idEvent);UnUsedParam(dwTime);
	if ( DispMesStock && (MouseStatus != MS_STOPTELOP)){
		DispMesX -= (FontSize.x * X_telopsp) / ((10 * 1000) / DispMesRate) + 1;
		DrawWindow(hWnd);
	}
}
