/*-----------------------------------------------------------------------------
	ClockPod / 풓sv									(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <dbt.h>
#include "CLOCKPOD.H"
#include "CLK_MSTR.C"

const TCHAR WMTASKBARCREATEstr[] = T(WMTASKBARCREATE);
const TCHAR AppNameStr[] = T(AppName);
const TCHAR AppNameHolderStr[] = T(AppName) T("32");

#ifndef DEVICE_NOTIFY_WINDOW_HANDLE
#define DEVICE_NOTIFY_WINDOW_HANDLE 0x00000000
typedef HANDLE HPOWERNOTIFY;
#endif

GUID xGUID_BATTERY_PERCENTAGE_REMAINING = {0xA7AD8041, 0xB45A, 0x4CAE,{0x87, 0xA3, 0xEE, 0xCB, 0xB4, 0x68, 0xA9, 0xE1}};

LOADWINAPISTRUCT RASAPI32DLL[] = {
	LOADWINAPI1T(RasEnumConnections), LOADWINAPI1T(RasGetConnectStatus),
	LOADWINAPI1T(RasHangUp),
	{NULL, NULL}
};

//------------------------------------- Init	n߂ɍsׂ
void Init(void)
{
	WNDCLASS wcClass;
	DWORD s;
	int coldboot, i;
	struct EVENTLOGLIST *el;
	DWORD StyleEx = WS_EX_TOPMOST | WS_EX_TOOLWINDOW;

	SetCurrentDirectory(ExePath);

	user_lang = GetUserDefaultLCID();
	if ( user_lang == LCID_JAPANESE ) TMsgStr = DefineMessageStringJ;

	for ( i = 0 ; i < MAXLINE ; i++ ) timetext[i][0] = '\0';
	OSver.dwOSVersionInfoSize = sizeof(OSver);
	GetVersionEx(&OSver);

	#if !defined(_WIN64)
		SetUnhandledExceptionFilter((LPTOP_LEVEL_EXCEPTION_FILTER)
				UnhandledExceptionFilterProc);
	#else
		#if 0 // ÂSDK̏ꍇ
		{
			#ifndef SEF_DACL_AUTO_INHERIT
				typedef LONG (NTAPI *PVECTORED_EXCEPTION_HANDLER)(
					struct _EXCEPTION_POINTERS *ExceptionInfo
				);
			#endif
			DefineWinAPI(PVOID, AddVectoredExceptionHandler,
					(ULONG First, PVECTORED_EXCEPTION_HANDLER Handler));

			GETDLLPROC(GetModuleHandleA("KERNEL32.DLL"), AddVectoredExceptionHandler);

			DAddVectoredExceptionHandler(0, (PVECTORED_EXCEPTION_HANDLER)
					UnhandledExceptionFilterProc);
		}
		#else
			AddVectoredExceptionHandler(0, UnhandledExceptionFilterProc);
		#endif
	#endif

	WM_TASKBARCREATE = RegisterWindowMessage(WMTASKBARCREATEstr);
	WM_CLOCKPOD = RegisterWindowMessage(AppNameStr);

	TimerNowTick = GetTickCount();
	lBoxFont.font.lfHeight  = GetSystemMetrics(SM_CYSIZE); // ftHgw
	ThInit(&cfgstr);
	ThInit(&cfgac);

	ahWnd = GetForegroundWindow();
	GetWndStyle();

	{
		HMODULE hUser32 = GetModuleHandleA("USER32.DLL");

		GETDLLPROC(hUser32, SetLayeredWindowAttributes);
		GETDLLPROC(hUser32, UpdateLayeredWindow);
	}

	for ( el = ELogList ; el->name != NULL ; el++ ){
		el->hLog = OpenEventLog(NULL, el->name);
		if ( el->hLog != NULL ){
			GetNumberOfEventLogRecords(el->hLog, &el->count);
		}
	}

	s = TSIZEOF(PCname);
	GetComputerName(PCname, &s);
	memset(&ConnectionList, 0, sizeof(ConnectionList));

										// EChENX` ---------
	wcClass.style			= CS_HREDRAW | CS_VREDRAW;
	wcClass.lpfnWndProc		= WndProc;
	wcClass.cbClsExtra		= 0;
	wcClass.cbWndExtra		= sizeof(HHOOK);
	wcClass.hInstance		= hMainInst;
	wcClass.hIcon			= LoadIcon(hMainInst, MAKEINTRESOURCE(Ic_ICON));
	wcClass.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wcClass.hbrBackground	= NULL;
	wcClass.lpszMenuName	= NULL;
	wcClass.lpszClassName	= AppNameStr;
										// NXo^
	RegisterClass(&wcClass);
										// EBhE쐬 -------------------
	if ( OSver.dwMajorVersion >= 5 ) StyleEx |= WS_EX_NOACTIVATE;

	hMainWnd= CreateWindowEx(StyleEx, AppNameStr, AppNameStr, WS_POPUP,
			0, 0, 0, 0, NULL, NULL, hMainInst, NULL);

	coldboot = Customize(1);

	if ( X_power ){
		GETDLLPROC(GetModuleHandleA("KERNEL32.DLL"), GetSystemPowerStatus);
		if ( DGetSystemPowerStatus != NULL ){
			DefineWinAPI(HPOWERNOTIFY, RegisterPowerSettingNotification,
					(HANDLE hRecipient, GUID *PowerSettingGuid, DWORD Flags));

			GETDLLPROC(GetModuleHandleA("USER32.DLL"), RegisterPowerSettingNotification);
			if ( DRegisterPowerSettingNotification != NULL ){
				hPowerNotify = DRegisterPowerSettingNotification(hMainWnd, &xGUID_BATTERY_PERCENTAGE_REMAINING, DEVICE_NOTIFY_WINDOW_HANDLE);
			}
		}
	}
	if ( X_ras ){
		hRASAPI32 = LoadWinAPI("RASAPI32.DLL", NULL, RASAPI32DLL);
	}
	if ( X_messenger ){
		hMessenger = CreateMailslot(T("\\\\.") T(MessengerName),
				0, MAILSLOT_WAIT_FOREVER, NULL);
		if ( hMessenger == INVALID_HANDLE_VALUE ) hMessenger = NULL;
	}
	hPodSlot = CreateMailslot(T("\\\\.") T(MailSlotName),
			0, MAILSLOT_WAIT_FOREVER, NULL);
	if ( hPodSlot == INVALID_HANDLE_VALUE ) hPodSlot = NULL;
	if ( X_ras != 0 ) SendPodSlot(T("*"), T("<Connections>"));
	SetTimer(hMainWnd, 1, INTERVAL, TimerProc);
	if (coldboot && X_boottelop) SetMessage(zNoID, T(BOOTMES), DMES_TELOP, NULL);
	StartMailCheck(B3, -1);
	BatteryCheckMain();
										// CEChE̕\XV -------
	ShowWindow(hMainWnd, SW_SHOWNOACTIVATE);
	MoveClock(hMainWnd);
	UpdateWindow(hMainWnd);
}
//------------------------------------- DLL z_[
#ifndef _WIN64
LRESULT CALLBACK HolderProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if ( message == WM_DESTROY ) PostQuitMessage(EXIT_SUCCESS);
	return DefWindowProc(hWnd, message, wParam, lParam);
}

void InitHolder(void)
{
	WNDCLASS wcClass;

	wcClass.style			= 0;
	wcClass.lpfnWndProc		= HolderProc;
	wcClass.cbClsExtra		= 0;
	wcClass.cbWndExtra		= 0;
	wcClass.hInstance		= hMainInst;
	wcClass.hIcon			= NULL;
	wcClass.hCursor			= NULL;
	wcClass.hbrBackground	= NULL;
	wcClass.lpszMenuName	= NULL;
	wcClass.lpszClassName	= AppNameHolderStr;
										// NXo^
	RegisterClass(&wcClass);
										// EBhE쐬 -------------------
	CreateWindowEx(0, AppNameHolderStr, AppNameHolderStr,
			0, 0, 0, 0, 0, NULL, NULL, hMainInst, NULL);
	UseCPodDLL(1);
}
#endif
//------------------------------------- I
void Close(void)
{
	TCHAR buf[0x100];
	CFG cfg;

	MailCheckBreak = MAILCHECK_OFF;
	Z_ExecAction(zExit, NULL);
	if ( CFGOpen(&cfg, cfgfile) ){
		WriteHex(buf, &DPosOFFS, sizeof(DPosOFFS));
		CFGReplaceLine(&cfg, 0, T("DPos"), buf);
		CFGClose(&cfg);
	}
	KillTimer(hMainWnd, 1);
	if ( DispMesRate ) KillTimer(hMainWnd, 2);
	if ( BallonText[0] != '\0' ) TrayMessage(hMainWnd, NIM_DELETE, 0, NULL, NULL);

	UnregisterHotKey(hMainWnd, KEYID_L);
	UnregisterHotKey(hMainWnd, KEYID_M);
	UnregisterHotKey(hMainWnd, KEYID_R);

	if ( hPowerNotify != NULL ){
		DefineWinAPI(BOOL, UnregisterPowerSettingNotification, (HPOWERNOTIFY Handle));
		GETDLLPROC(GetModuleHandleA("USER32.DLL"), UnregisterPowerSettingNotification);
		DUnregisterPowerSettingNotification(hPowerNotify);
	}

//	tPlaySound(NULL, SND_SYNC);	// ~
	if ( hMdc != NULL ){
		DeleteObject(SelectObject(hMdc, hOldMBMP));
		DeleteDC(hMdc);
		hMdc = NULL;
	}

	ThFree(&cfgstr);
	ThFree(&cfgac);
	if ( ResH != NULL ) FreeLibrary(ResH);
	DeleteObject(hBoxFont);

	if ( hRASAPI32 != NULL )	FreeLibrary(hRASAPI32);
	if ( hIMM32 != NULL )		FreeLibrary(hIMM32);
	if ( hDWMAPI != NULL )		FreeLibrary(hDWMAPI);
	if ( hPodSlot != NULL )		CloseHandle(hPodSlot);
	if ( hMessenger != NULL )	CloseHandle(hMessenger);

	{
		struct EVENTLOGLIST *el;

		for ( el = ELogList ; el->name != NULL ; el++ ){
			if ( el->hLog != NULL ) CloseEventLog(el->hLog);
		}
	}
}

/*-----------------------------------------------------------------------------
	WinMain
-----------------------------------------------------------------------------*/
#pragma warning(suppress: 28251) // SDK ɂ hPrevInstance ̑قȂ
#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	MSG msg;

#ifdef UNICODE
	const WCHAR *CmdLinePtr = GetCommandLine();
	UnUsedParam(lpszCmdLine);

	GetLineParam(&CmdLinePtr, cfgfile); // g̃pXXLbv
#else
	#define CmdLinePtr lpszCmdLine
#endif
	UnUsedParam(hPrevInstance);UnUsedParam(cmdShow);

#ifndef _WIN64
	if ( *CmdLinePtr != '*' )
#endif
	{
		HWND hWnd;

		hWnd = FindWindow(AppNameStr, AppNameStr);
		if ( hWnd != NULL ){
			ShowWindow(hWnd, SW_SHOW);
			return EXIT_FAILURE; // dN̋֎~
		}

		hMainInst = hInstance; // EChE֐Ŏgp邽߂ɕۑ
		GetModuleFileName(NULL, ExePath, MAX_PATH);
		*strschr(ExePath, '\\') = '\0';
		MakeCfgFilename(cfgfile, CmdLinePtr);
		Init();
		Z_ExecAction(zBoot, NULL);
										// DLL N
		UseCPodDLL( X_IME == 2 );
		SetTransparent();
#ifndef _WIN64
	}else{ // DLL z_[h
		if ( FindWindow(AppNameHolderStr, AppNameHolderStr) ) return EXIT_FAILURE;
		InitHolder();
#endif
	}
										// C[v -----------------------
	for(;;){
		if ( (int)GetMessage(&msg, NULL, 0, 0) <= 0 ) break;
		if ( (hSendWnd == NULL) || !IsDialogMessage(hSendWnd, &msg) ){
//			TranslateMessage(&msg);	// WM_CHAR gpȂ̂ŃRgAEg
//			 _CAO{bNX͎Õ[vȂ̂ŖȂWM_CHAR@\
			DispatchMessage(&msg);
		}
	}
	UseCPodDLL(0);
	return EXIT_SUCCESS;
}
