/*-----------------------------------------------------------------------------
	ُIe̕	(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <imagehlp.h>
#include "CLOCKPOD.H"
#pragma hdrstop

#define FileProp_Version File_Version
#define FaultLog(log) LogWrite(0x999, log)
#define AppExeName T("CLOCKPOD")


#ifdef _M_ARM
	#define MSGBIT T("ARM")
	#define REGPREFIX(reg) reg
	#define CHECK_LoadDLL "LoadDLL"

	#define CPUTYPE IMAGE_FILE_MACHINE_ARM
	#define LOADWINAPI164(name) {(void (WINAPI **)())&(D ## name), #name}
	#define TAIL64(name) name
	#ifdef UNICODE
		#define LOADWINAPI164TW(name) {(void (WINAPI **)())&(D ## name), #name "W"}
		#define TAIL64T(name) name ## W
	#else
		#define LOADWINAPI164TW(name) {(void (WINAPI **)())&(D ## name), #name}
		#define TAIL64T(name) name
	#endif
#endif

#ifdef _M_ARM64
	#define MSGBIT T("ARM64")
	#define REGPREFIX(reg) reg
	#define CHECK_LoadDLL "LoadDLL64"

	#define CPUTYPE IMAGE_FILE_MACHINE_ARM64
	#define LOADWINAPI164(name) {(void (WINAPI **)())&(D ## name), #name}
	#define TAIL64(name) name
	#ifdef UNICODE
		#define LOADWINAPI164TW(name) {(void (WINAPI **)())&(D ## name), #name "W"}
		#define TAIL64T(name) name ## W
	#else
		#define LOADWINAPI164TW(name) {(void (WINAPI **)())&(D ## name), #name}
		#define TAIL64T(name) name
	#endif
#endif

#ifndef CPUTYPE
	#ifdef _WIN64
		#define MSGBIT T("x64")
		#define REGPREFIX(reg) R ## reg
		#define CHECK_LoadDLL "LoadDLL64"

		#define CPUTYPE IMAGE_FILE_MACHINE_AMD64
		#define LOADWINAPI164(name) {(void (WINAPI **)())&(D ## name), #name "64"}
		#define TAIL64(name) name ## 64
		#ifdef UNICODE
			#define LOADWINAPI164TW(name) {(void (WINAPI **)())&(D ## name), #name "W64"}
			#define TAIL64T(name) name ## W64
		#else
			#define LOADWINAPI164TW(name) {(void (WINAPI **)())&(D ## name), #name "64"}
			#define TAIL64T(name) name ## 64
		#endif
	#else
		#define MSGBIT
		#define REGPREFIX(reg) E ## reg
		#define CHECK_LoadDLL "LoadDLL"

		#define CPUTYPE IMAGE_FILE_MACHINE_I386
		#define LOADWINAPI164(name) {(void (WINAPI **)())&(D ## name), #name}
		#define TAIL64(name) name
		#ifdef UNICODE
			#define LOADWINAPI164TW(name) {(void (WINAPI **)())&(D ## name), #name "W"}
			#define TAIL64T(name) name ## W
		#else
			#define LOADWINAPI164TW(name) {(void (WINAPI **)())&(D ## name), #name}
			#define TAIL64T(name) name
		#endif
	#endif
#endif

#ifdef UNICODE
	#define MSGVER	T(FileProp_Version) T(" UNICODE ") MSGBIT T("(") T(__DATE__) T(")")
	#define MSGCTYPE T("U") MSGBIT
#else
	#define MSGVER	T(FileProp_Version) T(" Multibyte(") T(__DATE__) T(")")
	#define MSGCTYPE T("M")
#endif

const TCHAR msgtitle[] = T(AppName) T(" Internal Error");
const TCHAR NoItem[] = T("-");
//const TCHAR NilStr[] = T("");
//------------------------------------------------------------ O\e[u
#define msgstr_fault 0
#define msgstr_except 1
#define msgstr_unknownthread 2
#define msgstr_memaddress 3
#define msgstr_faultread 4
#define msgstr_faultwrite 5
#define msgstr_div0 6
#define msgstr_sendreport 7
#define msgstr_faultsend 8
#define msgstr_faultDEP 19

const TCHAR *msgstringsJ[] = {
	T("%s ŁA%sُ̑ΏłȂ߁AI܂B\n")
	T("  ڍ\tWin%d.%d,") MSGVER T("\n%s\n%s%s"), // 0 msgstr_fault

	T("O %XH"), // 1 msgstr_except
	T("s"), // 2 msgstr_unknownthread
	T("(") T(PTRPRINTFORMAT) T("H)%ss"), // 3 msgstr_memaddress
	T("Ǎ"), // 4 msgstr_faultread
	T(""), // 5 msgstr_faultwrite
	T("0Z"), // 6 msgstr_div0
	T("u͂vŁAuEUJđOLê݂҂ɑM܂B\n")
	T("΍ł邩܂̂ŁAłΑM肢܂B"), // 7 msgstr_sendreport
	T("MɎs܂B"), // 8 msgstr_faultsend
	T("DEP"), // 9 msgstr_faultDEP
};

const TCHAR *msgstringsE[] = {
	T("Detected error in %s thread.\n")
	T("Terminating ") T(AppName) T(" by %s error.\n")
	T(" detail\tWin%d.%d,") MSGVER T("\n%s\n%s%s"), // 0

	T("Exception %XH"),
	T("Unknown"),
	T(PTRPRINTFORMAT) T("H %s memory access fault"),
	T("Read"),
	T("Write"),
	T("Divide by zero"),
	T("When you select 'yes', this report is sent to TORO."),
	T("send fault."),
	T("DEP"),
};

#ifndef EXCEPTION_IN_PAGE_ERROR
	#define EXCEPTION_IN_PAGE_ERROR 0xC0000006
#endif

#define STACKWALKSIZE 0x3000

#if defined(UNICODE) && !defined(CBA_READ_MEMORY) && !defined(WINEGCC)
typedef struct {
	DWORD SizeOfStruct, BaseOfImage, ImageSize, TimeDateStamp, CheckSum, NumSyms;
	SYM_TYPE SymType;
	WCHAR ModuleName[32], ImageName[256], LoadedImageName[256];
} IMAGEHLP_MODULEW, *PIMAGEHLP_MODULEW;
#endif
DefineWinAPI(BOOL, StackWalk, (DWORD, HANDLE, HANDLE, TAIL64(LPSTACKFRAME), PVOID,
	TAIL64(PREAD_PROCESS_MEMORY_ROUTINE),
	TAIL64(PFUNCTION_TABLE_ACCESS_ROUTINE),
	TAIL64(PGET_MODULE_BASE_ROUTINE),
	TAIL64(PTRANSLATE_ADDRESS_ROUTINE))
) = NULL;

DefineWinAPI(BOOL, SymInitialize, (HANDLE, PCSTR, BOOL)) = NULL;
DefineWinAPI(PVOID, SymFunctionTableAccess, (HANDLE, DWORD_PTR));
DefineWinAPI(BOOL, SymGetSymFromAddr,
	(HANDLE, DWORD_PTR, DWORD_PTR *, TAIL64(IMAGEHLP_SYMBOL) *));
DefineWinAPI(BOOL, SymCleanup, (HANDLE));

DefineWinAPI(DWORD_PTR, SymGetModuleBase, (HANDLE, DWORD_PTR));
DefineWinAPI(BOOL, SymGetModuleInfo, (HANDLE, DWORD_PTR, TAIL64T(IMAGEHLP_MODULE) *)) = NULL;

LOADWINAPISTRUCT IMAGEHLPDLL[] = {
	LOADWINAPI164(StackWalk),
	LOADWINAPI1(SymInitialize),
	LOADWINAPI164(SymFunctionTableAccess),
	LOADWINAPI164(SymGetModuleBase),
	LOADWINAPI164(SymGetSymFromAddr),
	LOADWINAPI1(SymCleanup),
	LOADWINAPI164TW(SymGetModuleInfo),
	{NULL, NULL}
};

#define defThreadQuerySetWin32StartAddress 9

int ShowErrorDialog(const TCHAR **Msg, const TCHAR *threadtext, const TCHAR *infotext, const TCHAR *addrtext, const TCHAR *comment);

#define CMDLINESIZE 1000

HANDLE LoadWinAPI(const char *DLLname, HMODULE hDLL, LOADWINAPISTRUCT *apis)
{
	if ( hDLL == NULL ){
		hDLL = LoadLibraryA(DLLname);
		if ( hDLL == NULL ) return NULL;
	}

	while (apis->APIname != NULL){
		*apis->APIptr = (void (WINAPI *)())GetProcAddress(hDLL, apis->APIname);
		if ( *apis->APIptr == NULL ){
			FreeLibrary(hDLL);
			return NULL;
		}
		apis++;
	}
	return hDLL;
}

void QueryEncode(TCHAR *dst)
{
	char bufA[CMDLINESIZE], *srcA;
	TCHAR *dest, *max;

#ifdef UNICODE
	WideCharToMultiByte(CP_UTF8, 0, dst, -1, bufA, CMDLINESIZE, NULL, NULL);
#else
	WCHAR bufW[CMDLINESIZE];

	AnsiToUnicode(dst, bufW, CMDLINESIZE);
	WideCharToMultiByte(CP_UTF8, 0, bufW, -1, bufA, CMDLINESIZE, NULL, NULL);
#endif
	srcA = bufA;
	dest = dst;
	max = dest + CMDLINESIZE / 2;
	while ( dest < max ){
		BYTE c;

		c = (BYTE)*srcA++;
		if ( c == '\0' ) break;
		if ( IsalnumA(c) || (c == '=') ){
			*dest++ = c;
		}else if ( c == '\1' ){
			*dest++ = '&';
		}else if ( c == ' ' ){
			*dest++ = '+';
		}else{
			dest += wsprintf(dest, T("%%%02X"), c);
		}
	}
	*dest = '\0';
}

// address ( modulename [basename].funcname + offset `o͂
void GetFailedModuleAddr(HANDLE hProcess, TAIL64(IMAGEHLP_SYMBOL) *syminfo, TCHAR *dest, void *addr)
{
	TAIL64T(IMAGEHLP_MODULE) mdlinfo;
	DWORD_PTR funcoffset;

	// address
	dest += wsprintf(dest, T(PTRPRINTFORMAT), addr);
	mdlinfo.SizeOfStruct = sizeof(mdlinfo);
	// modulename, basename
	if ( (DSymInitialize != NULL) && IsTrue(DSymGetModuleInfo(
			GetCurrentProcess(), (DWORD_PTR)addr, &mdlinfo)) ){
		dest += wsprintf(dest, T("(%s:") T(PTRPRINTFORMAT),
					mdlinfo.ModuleName, mdlinfo.BaseOfImage);
	}
	// funcname, offset
	if ( (DSymInitialize != NULL) && IsTrue(DSymGetSymFromAddr(
			hProcess, (DWORD_PTR)addr, &funcoffset, syminfo)) ){
		#ifdef UNICODE
		WCHAR funcnameW[256];

		AnsiToUnicode(syminfo->Name, funcnameW, 256);
		dest += wsprintf(dest, T(".%s+") T(PTRPRINTFORMAT), funcnameW, funcoffset);
		#else
		dest += wsprintf(dest, T(".%s+") T(PTRPRINTFORMAT), syminfo->Name, funcoffset);
		#endif
	}
	*dest++ = ')';
	*dest = '\0';
}

//-------------------------------------------------------------------- O
#define SHOWSTACKS 3 // W̃X^bN\
#define SHOWSTACKSBUFSIZE 0x200

LONG UnhandledExceptionFilterProc(EXCEPTION_POINTERS *ExceptionInfo)
{
	HANDLE hThread, hProcess;
	HMODULE hKernel32;

	EXCEPTION_RECORD *ExceptionRecord = ExceptionInfo->ExceptionRecord;
	DWORD_PTR checkaddr = (DWORD_PTR)ExceptionRecord->ExceptionAddress;
	DWORD_PTR targetaddr;
	DWORD ExceptionCode = ExceptionRecord->ExceptionCode;

	char symblebuffer[STACKWALKSIZE];
	TAIL64(IMAGEHLP_SYMBOL) *syminfo;

	TCHAR threadnamebuf[0x100];
	const TCHAR *threadname;

	TCHAR exceptionbuf[256], stackinfo[SHOWSTACKSBUFSIZE + 16], *stackptr;
	const TCHAR **Msg = msgstringsE;
	const TCHAR *Comment = NilStr;
	int result;
	TAIL64(STACKFRAME) sframe;

	if ( ExceptionCode & B29 ){ // [U`
		return EXCEPTION_CONTINUE_SEARCH;
	}

	if ((ExceptionCode != EXCEPTION_ACCESS_VIOLATION) &&
//		(ExceptionCode != EXCEPTION_DATATYPE_MISALIGNMENT) && // EANZXᔽ
		(ExceptionCode != EXCEPTION_FLT_INVALID_OPERATION) &&
		(ExceptionCode != EXCEPTION_IN_PAGE_ERROR) &&
		(ExceptionCode != EXCEPTION_STACK_OVERFLOW) &&
		(ExceptionCode != EXCEPTION_INT_DIVIDE_BY_ZERO) ){
		return EXCEPTION_CONTINUE_SEARCH;
	}
	// IsBadWritePtr/IsBadReadPtr ͖
	hKernel32 = GetModuleHandle(T("KERNEL32.DLL"));
	targetaddr = (DWORD_PTR)GetProcAddress(hKernel32, "IsBadWritePtr");
	if ( targetaddr != 0 ){
		if ( (checkaddr >= (targetaddr - 0x60)) &&
			 (checkaddr < targetaddr + 0x140) ){
			return EXCEPTION_CONTINUE_SEARCH;
		}
		targetaddr = (DWORD_PTR)GetProcAddress(hKernel32, "IsBadReadPtr");
		if ( (checkaddr >= (targetaddr - 0x60)) &&
			 (checkaddr < targetaddr + 0x140) ){
			return EXCEPTION_CONTINUE_SEARCH;
		}
	}

	if ( LOWORD(GetUserDefaultLCID()) == LCID_JAPANESE ) Msg = msgstringsJ;

	hProcess = GetCurrentProcess();
	hThread = GetCurrentThread();

	// fobOAV{擾̏
	if ( DSymInitialize == NULL ){
		LoadWinAPI("IMAGEHLP.DLL", NULL, IMAGEHLPDLL);
	}
	if ( DSymInitialize != NULL ){
		DSymInitialize(hProcess, NULL, TRUE);
		syminfo = (TAIL64(IMAGEHLP_SYMBOL) *)symblebuffer;
		syminfo->SizeOfStruct = STACKWALKSIZE;
		syminfo->MaxNameLength = STACKWALKSIZE - sizeof(TAIL64(IMAGEHLP_SYMBOL));
	}

	// Thread name擾
	{
		DefineWinAPI(LONG, NtQueryInformationThread, (HANDLE, int, PVOID, ULONG, PULONG));

		GETDLLPROC(GetModuleHandleA("ntdll.dll"), NtQueryInformationThread);
		if ( DNtQueryInformationThread == NULL ){
			threadname = Msg[msgstr_unknownthread];
		}else{
			ULONG ulLength;
			PVOID pBeginAddress = NULL;

			DNtQueryInformationThread(hThread,
					defThreadQuerySetWin32StartAddress, &pBeginAddress,
					sizeof(pBeginAddress), &ulLength);

			GetFailedModuleAddr(hProcess, syminfo, threadnamebuf, pBeginAddress);
			threadname = threadnamebuf;
		}
	}
	// Oڍ exception
	ExceptionRecord->ExceptionFlags = EXCEPTION_NONCONTINUABLE;
	if ( (ExceptionCode == EXCEPTION_ACCESS_VIOLATION) ||
		 (ExceptionCode == EXCEPTION_IN_PAGE_ERROR) ){
		DWORD rwmode = msgstr_faultread;
		DWORD rwinfo = (DWORD)ExceptionRecord->ExceptionInformation[0];

		if ( rwinfo ){
			rwmode = (rwinfo == 8) ? msgstr_faultDEP : msgstr_faultwrite;
		}
		wsprintf(exceptionbuf, Msg[msgstr_memaddress],
				ExceptionRecord->ExceptionInformation[1], Msg[rwmode]);
	}else if ( ExceptionCode == EXCEPTION_INT_DIVIDE_BY_ZERO){
		tstrcpy(exceptionbuf, Msg[msgstr_div0]);
	}else{
		wsprintf(exceptionbuf, Msg[msgstr_except], ExceptionCode);
	}

	stackptr = stackinfo;
	stackinfo[0] = '\0';

	// X^bN/OAhX stackinfo
	if ( DStackWalk != NULL ){
		BOOL findapp = FALSE;
		CONTEXT targetThc;
		int stacks = SHOWSTACKS;
		int count = 0;

		targetThc = *ExceptionInfo->ContextRecord;
		targetThc.ContextFlags = CONTEXT_FULL;
		memset(&sframe, 0, sizeof(sframe));

#if defined(_M_ARM) || defined(_M_ARM64)
		sframe.AddrPC.Offset = ExceptionInfo->ContextRecord->REGPREFIX(Pc);
		sframe.AddrStack.Offset = ExceptionInfo->ContextRecord->REGPREFIX(Sp);
		sframe.AddrFrame.Offset = 0;
#else
		sframe.AddrPC.Offset = ExceptionInfo->ContextRecord->REGPREFIX(ip);
		sframe.AddrStack.Offset = ExceptionInfo->ContextRecord->REGPREFIX(sp);
		sframe.AddrFrame.Offset = ExceptionInfo->ContextRecord->REGPREFIX(bp);
#endif
		sframe.AddrPC.Mode = AddrModeFlat;
		sframe.AddrStack.Mode = AddrModeFlat;
		sframe.AddrFrame.Mode = AddrModeFlat;
		if ( ExceptionCode == EXCEPTION_STACK_OVERFLOW ){
			stacks += 3;
		}

		for (;;) {
			TCHAR addrstr[512];
			BOOL walkresult;

			count++;
			walkresult = DStackWalk(CPUTYPE, hProcess, hThread, &sframe,
					&targetThc, NULL, DSymFunctionTableAccess,
					DSymGetModuleBase, NULL);
			if ( !walkresult || (sframe.AddrPC.Offset == sframe.AddrReturn.Offset)){
				break;
			}
			// G[AhXLڂĂȂƂ͒ǉ
			if ( (stacks == SHOWSTACKS) &&
				((void *)sframe.AddrPC.Offset !=
					 (void *)ExceptionRecord->ExceptionAddress) ){
				GetFailedModuleAddr(hProcess, syminfo, addrstr,
						ExceptionRecord->ExceptionAddress);
				FaultLog(addrstr);
				stackptr += wsprintf(stackptr, T("\t*%s\n"), addrstr);
			}
			// wAhX̏L
			GetFailedModuleAddr(hProcess, syminfo, addrstr,
					(void *)sframe.AddrPC.Offset);
			FaultLog(addrstr);

			if ( stacks || !findapp ){ // csL肩AAppĂȂ
				if ( !findapp && (tstrstr(addrstr, T("(") AppExeName) != NULL)){
					findapp = TRUE;
					if ( stacks <= 1 ) stacks = 2;
				}

				if ( (stacks || findapp) &&
					 (((stackptr - stackinfo) + tstrlen(addrstr)) < (SHOWSTACKSBUFSIZE - 8)) ){
					stackptr += wsprintf(stackptr, T("\t%d:%s\n"), count, addrstr);
					if ( stacks ) stacks--;
				}
			}
		}
	}
	if ( stackinfo == stackptr ){
		GetFailedModuleAddr(hProcess, syminfo, stackinfo,
				ExceptionRecord->ExceptionAddress);
	}
	if ( DSymInitialize != NULL ) DSymCleanup(hProcess);

	result = ShowErrorDialog(Msg, threadname, exceptionbuf, stackinfo, Comment);
	if ( result == IDCANCEL ) return EXCEPTION_CONTINUE_SEARCH;
	ExitProcess(ExceptionCode);
	return EXCEPTION_EXECUTE_HANDLER;
}

const TCHAR OSverinfo[] = T("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion");
const TCHAR ReleaseId[] = T("ReleaseId");
int ShowErrorDialog(const TCHAR **Msg, const TCHAR *threadtext, const TCHAR *infotext, const TCHAR *addrtext, const TCHAR *comment)
{
	TCHAR msgbuf[0x400], *typename;
	int result;
	DWORD OSsubver;

	if ( OSver.dwMajorVersion >= 10 ){
		const TCHAR *ptr;

		msgbuf[0] = '\0';
		GetRegString(HKEY_LOCAL_MACHINE, OSverinfo, ReleaseId, msgbuf, TSIZEOF(msgbuf));
		ptr = msgbuf;
		OSsubver = GetNumber(&ptr);
	}else{
		OSsubver = OSver.dwMinorVersion;
	}
	wsprintf(msgbuf, Msg[msgstr_fault], threadtext, infotext,
			OSver.dwMajorVersion, OSsubver,
			addrtext, Msg[msgstr_sendreport], comment);
	typename = T("fault");
	msgbuf[TSIZEOF(msgbuf) - 8] = '\0';
	FaultLog(msgbuf);
	result = MessageBox(NULL, msgbuf, msgtitle,
			MB_YESNOCANCEL | MB_DEFBUTTON2 | MB_ICONSTOP);
	if ( result == IDYES ){
		wsprintf(msgbuf, REPORTURL T("?exe=") T(AppName)
			T("\1ver=") T(FileProp_Version) MSGCTYPE
			T("\1type=%s\1thread=%s\1info=%s\1os=%d.%d\1addr=%s"),
			typename, threadtext, infotext,
			OSver.dwMajorVersion, OSsubver, addrtext);
		msgbuf[TSIZEOF(msgbuf) - 8] = '\0';
		QueryEncode(tstrchr(msgbuf, '?') + 1);
		ShellExecute(NULL, NULL, msgbuf, NULL, NilStr, 0);
	}
	return result;
}
