/*-----------------------------------------------------------------------------
	HDTEMP service	Copyright (c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <string.h>

#include "TOROWIN.H"
#include "SERVICE.H"
#include "HWINFS.H"
#include "TSECU.H"
#pragma hdrstop

#define CPUTCC 85

// WinRing0.dll ̒`
// WinRing0.sys ͕W[Ułpł̂Œ!!

DefineWinAPI(BOOL, InitializeOls, (void));
DefineWinAPI(VOID, DeinitializeOls, (void));
DefineWinAPI(BOOL, IsMsr, (void));
DefineWinAPI(BOOL, Rdmsr, (DWORD index, PDWORD eax, PDWORD edx));
DefineWinAPI(BOOL, RdmsrTx, (DWORD index, PDWORD eax, PDWORD edx, DWORD_PTR affinityMask));
DefineWinAPI(BYTE, ReadIoPortByte, (WORD address));
DefineWinAPI(WORD, ReadIoPortWord, (WORD address));
DefineWinAPI(VOID, WriteIoPortByte, (WORD address, BYTE value));
DefineWinAPI(VOID, WriteIoPortWord, (WORD address, WORD value));

typedef struct {
	void (WINAPI **APIptr)();	// 擾APIւ̃|C^(ŏIȂ NULL)
	const char *APIname;		// 擾API̖O
} LOADWINAPISTRUCT;

#define LOADWINAPI1(name)	{(void (WINAPI **)())&(D ## name), #name}

LOADWINAPISTRUCT WINRING0DLL[] = {
	LOADWINAPI1(InitializeOls),
	LOADWINAPI1(DeinitializeOls),
	LOADWINAPI1(IsMsr),
	LOADWINAPI1(Rdmsr),
	LOADWINAPI1(RdmsrTx),
	LOADWINAPI1(ReadIoPortByte),
	LOADWINAPI1(ReadIoPortWord),
	LOADWINAPI1(WriteIoPortByte),
	LOADWINAPI1(WriteIoPortWord),
	{NULL, NULL}
};

DWORD CPUtemp[4];

BOOL GetCPUTemp(void);
DWORD GetHdTemp(const char *command, char *dest);
HANDLE hWinRing0 = NULL;

#define CMD_NONE	0
#define CMD_END		-1
int Command = CMD_NONE;	// wߗp

//================================================================ C[v
DWORD StartMain(void)
{
	HANDLE hPipe;
	char Buffer[PipeBuffers];
	SECURITY_ATTRIBUTES sa;

	sa.nLength = sizeof sa;
	sa.lpSecurityDescriptor = MakeEveryoneSecurity();
	sa.bInheritHandle = FALSE;

	hPipe = CreateNamedPipe( T(PipeName), PIPE_ACCESS_DUPLEX,
			PIPE_TYPE_MESSAGE | PIPE_WAIT, 1, PipeBuffers, PipeBuffers,
				PIPEWAITTIME, &sa);
	LocalFree((HLOCAL)sa.lpSecurityDescriptor);

	if ( hPipe == INVALID_HANDLE_VALUE ){
		DebugLog("pipe open error", NULL);
		return FALSE;
	}
							// 
	ReportService(SERVICE_RUNNING, NO_ERROR, 0);
										// C -----------------------------
	for (;;){
		DWORD size;

		DebugLog("Ready", NULL);
		if ( ConnectNamedPipe(hPipe, NULL) == FALSE ) break;
		if ( Command == CMD_END ) break;
		Command = CMD_NONE;

		if ( ReadFile(hPipe, Buffer, PipeBuffers - 1, &size, NULL) != FALSE){
			Buffer[size] = '\0';
			size = GetHdTemp(Buffer, Buffer);
			if ( size ){
				WriteFile(hPipe, Buffer, size, &size, NULL);
			}else{
				WriteFile(hPipe, "!", 2, &size, NULL);
			}
		}else{
			DebugLog("Error", NULL);
			wsprintfA(Buffer, "!%d", GetLastError());
			DebugLog(Buffer, NULL);
			WriteFile(hPipe, Buffer, (DWORD)(strlen(Buffer) + 1), &size, NULL);
		}

		FlushFileBuffers(hPipe);
		DisconnectNamedPipe(hPipe);
	}
	CloseHandle(hPipe);

	if ( hWinRing0 != NULL ){
		DDeinitializeOls();
		FreeLibrary(hWinRing0);
		hWinRing0 = NULL;
	}

	DebugLog("end", NULL);
										// n -----------------------------
	return NO_ERROR;
}
//======================================================== [vI𖽗߂
void StopMain(void)
{
	char ReadBuffer[PipeReadBuffers];
	DWORD size;

	Command = CMD_END;
	CallNamedPipe( T(PipeName), "", 0,
			ReadBuffer, sizeof ReadBuffer - 1, &size, PIPEWAITTIME);
};

DWORD GetDiskdata(DWORD driveNo, BYTE command, void *iorecv, size_t iorecvsize, DWORD *subsize)
{
	TCHAR path[MAX_PATH];
	HANDLE hDrive;
	SENDCMDINPARAMS ioparam;
	DWORD tmpsize;
	BOOL result;

	wsprintf(path, T("\\\\.\\PhysicalDrive%d"), driveNo);
	DebugLog(path, NULL);
	hDrive = CreateFile(path, GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ | FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0);
	if ( hDrive == INVALID_HANDLE_VALUE ) return 0;
	DebugLog("open ok", NULL);

	memset(&ioparam, 0, sizeof(ioparam));
	if ( command == ATAPI_SMART ){
		ioparam.irDriveRegs.bFeaturesReg = READ_ATTRIBUTES;
		ioparam.irDriveRegs.bCylLowReg   = SMART_CYL_LOW;
		ioparam.irDriveRegs.bCylHighReg  = SMART_CYL_HI;
	}
	ioparam.irDriveRegs.bDriveHeadReg = (UCHAR)(0xA0 | ((driveNo & 1) << 4));
	ioparam.irDriveRegs.bCommandReg   = command;
	ioparam.cBufferSize               = READ_ATTRIBUTE_BUFFER_SIZE;
	ioparam.bDriveNumber              = (UCHAR)driveNo;

	result = DeviceIoControl(hDrive, DFP_RECEIVE_DRIVE_DATA,
			&ioparam, sizeof(ioparam),
			(SENDCMDOUTPARAMS *)iorecv, (DWORD)iorecvsize, &tmpsize, 0);

	if ( (subsize != NULL) && IsTrue(result) ){
		ioparam.irDriveRegs.bFeaturesReg = ATAPI_SMART_THRESHOLD;
		*subsize = 0;
		DeviceIoControl(hDrive, DFP_RECEIVE_DRIVE_DATA,
				&ioparam, sizeof(ioparam),
				(SENDCMDOUTPARAMS *)((BYTE *)iorecv + iorecvsize / 2),
				(DWORD)(iorecvsize / 2), subsize, 0);
	}

	CloseHandle(hDrive);
	if ( result == FALSE ) return 0;
	DebugLog("read ok", NULL);
	if ( tmpsize < sizeof(SENDCMDOUTPARAMS) ) return 0;
	return (tmpsize - sizeof(SENDCMDOUTPARAMS) + 1);
}

DWORD GetHdTemp(const char *command, char *dest)
{
	struct {
		SENDCMDOUTPARAMS param;
		BYTE data[READ_ATTRIBUTE_BUFFER_SIZE - 1];
	} iorecv[2];
	DRIVEATTRIBUTE *da, *damax;
	DWORD driveNo, smartsize, smartsize2, *subsize = NULL;
	BYTE commendID;

	if ( command[0] != 'H' ){
		if ( (command[0] == 'C') && (command[1] == 'T') ){
			if ( GetCPUTemp() == FALSE ) return 0;
			driveNo = command[2] - '1';
			if ( driveNo > 1 ) driveNo = 0;
			return wsprintfA(dest, "%d", CPUtemp[driveNo]) + 1;
		}
		return 0;
	}
	switch ( command[1] ){
		case 'I': commendID = ATAPI_IDENTIFY; break;
		case 'B':
			subsize = &smartsize2;
			// 'T' 
		case 'S': // 'T' 
		case 'T': commendID = ATAPI_SMART; break;
		default:
			return 0;
	}
	driveNo = command[2] - '1';
	if ( driveNo > 9 ) driveNo = 0;

	smartsize = GetDiskdata(driveNo, commendID, &iorecv, sizeof(iorecv), subsize);
	if ( smartsize == 0 ) return 0;

	switch ( command[1] ){
		case 'T':
			da = (DRIVEATTRIBUTE *)(iorecv[0].param.bBuffer + 2);
			damax = (DRIVEATTRIBUTE *)(iorecv[0].param.bBuffer + smartsize);

			for ( ; da < damax ; da++ ){
				if ( da->bAttrID == 0 ) break;
				if ( da->bAttrID == 0xC2 ){
					return wsprintfA(dest, "%d", da->bRawValue[0]) + 1;
				}
			}
			break;

		case 'B':
			*(DWORD *)dest = smartsize;
			memcpy(dest + sizeof(DWORD), iorecv[0].param.bBuffer, smartsize);
			if ( smartsize2 != 0 ){
				memcpy(dest + sizeof(DWORD) + smartsize, iorecv[1].param.bBuffer, smartsize2);
			}
			return sizeof(DWORD) + smartsize + smartsize2;

		default:
			memcpy(dest, iorecv[0].param.bBuffer, smartsize);
			return smartsize;
	}
	DebugLog("no data", NULL);
	return 0;
}

HANDLE LoadWinAPI(const char *DLLname, LOADWINAPISTRUCT *apis)
{
	HANDLE hDLL;

	hDLL = LoadLibraryA(DLLname);
	if ( hDLL == NULL ) return NULL;
	while ( apis->APIname != NULL ){
		*apis->APIptr = (void (WINAPI *)())GetProcAddress(hDLL, apis->APIname);
		if ( *apis->APIptr == NULL ){
			FreeLibrary(hDLL);
			return NULL;
		}
		apis++;
	}
	return hDLL;
}

BOOL LoadDriver(void)
{
	if ( hWinRing0 != NULL ) return TRUE;

	hWinRing0 = LoadWinAPI("WinRing0.dll", WINRING0DLL);
	if ( hWinRing0 == NULL ) return FALSE;
	if ( DInitializeOls() == FALSE ){
		FreeLibrary(hWinRing0);
		hWinRing0 = NULL;
		return FALSE;
	}
	return TRUE;
}

int enableMSR = -1;
DWORD CPUtick;
BOOL GetCPUTemp(void)
{
	DWORD eax = 0, edx = 0, tick;

	tick = GetTickCount();
	if ( (tick - CPUtick) < 1000 ) return FALSE;
	CPUtick = tick;

	if ( LoadDriver() == FALSE ){
		DebugLog("WinRing0.dll load error", NULL);
		return FALSE;
	}
	if ( enableMSR == 0 ) return FALSE;
	if ( enableMSR < 0 ){
		if ( DIsMsr() == FALSE ){
			enableMSR = 0;
			DebugLog("MSR can't use", NULL);
			return FALSE;
		}
		enableMSR = 1;
	}
	if ( DRdmsrTx(0x0000019C, &eax, &edx, 1) == FALSE ){
		DebugLog("MSR read error", NULL);
		return FALSE;
	}
	DebugLog("MSR read", NULL);
	CPUtemp[0] = CPUTCC - ((eax >> 16) & 0x3f);
	DRdmsrTx(0x0000019C, &eax, &edx, 2);
	CPUtemp[1] = CPUTCC - ((eax >> 16) & 0x3f);
	DRdmsrTx(0x00000198, &eax, &edx, 1);
	return TRUE;
}
