/*-----------------------------------------------------------------------------
	service 									Copyright (c)2000-2018 TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <winsvc.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <tchar.h>

#include "TOROWIN.H"
#include "SERVICE.H"
#pragma hdrstop

//-------------------------------------------------------------- O[oϐ
SERVICE_STATUS			SStatus;
SERVICE_STATUS_HANDLE	hSStatus;

//-------------------------------------------------------------- ֐
VOID WINAPI ServiceMain(DWORD argc, LPTSTR *argv);
VOID WINAPI ServiceHandler(DWORD dwCtrlCode);
UTCHAR GetLineParam(TCHAR **str, TCHAR *param);

int InstallService(void);
int RemoveService(void);

//-------------------------------------- {\tgŗp\ȃT[rẌꗗ
SERVICE_TABLE_ENTRY ServiceTable[] ={
	{T(APPNAME), (LPSERVICE_MAIN_FUNCTION)ServiceMain},
	{NULL, NULL}
};
//-------------------------------------- C
//int main(int argc, char **argv){ ]ȃCut߁AOŏ
int __cdecl main(void)
{
	int result = -2;
	TCHAR *p, param[MAX_PATH];

	p = GetCommandLine();
	GetLineParam(&p, param);	// g̖OXLbv
	while ( GetLineParam(&p, param) && (result < 0) ){
		if ( (param[0] == '-') || (param[0] == '/') ){
			if ( !tstricmp( T("install"), param + 1 ) ){
				result = InstallService();
			}else if ( !tstricmp( T("remove"), param + 1 ) ){
				result = RemoveService();
			}
		}
	}
	if ( result == -2 ){
		if ( StartServiceCtrlDispatcher(ServiceTable) == FALSE ){
			Print(USAGE);
			DebugLog("StartServiceCtrlDispatcher error", NULL);
			result = EXIT_FAILURE;
		}else{
			result = EXIT_SUCCESS;
		}
	}
	return result;
}
//-------------------------------------- T[rXC
#pragma argsused
void WINAPI ServiceMain(DWORD argc, LPTSTR *argv)
{
	DWORD result = NO_ERROR;

	hSStatus = RegisterServiceCtrlHandler(T(APPNAME), ServiceHandler);
	if ( hSStatus == NULL ){
		DebugLog("ServiceMain error", NULL);
		return;
	}
	SStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
	SStatus.dwServiceSpecificExitCode = 0;
													// T[rXJn
	if (ReportService(SERVICE_START_PENDING, NO_ERROR, 1000)){
		result = StartMain();
	}
													// T[rX̏Iʒm
	ReportService(SERVICE_STOPPED, result, 0);
	return;
}
//-------------------------------------- T[rXnh
void WINAPI ServiceHandler(DWORD dwCtrlCode)
{
	switch(dwCtrlCode){
		case SERVICE_CONTROL_STOP:		// T[rX̏Is
		case SERVICE_CONTROL_SHUTDOWN:	// Vbg_Ěn
			ReportService(SERVICE_STOP_PENDING, NO_ERROR, 500);
			StopMain();
			return;

//		case SERVICE_CONTROL_INTERROGATE:
		default:
			break;
	}
	ReportService(SStatus.dwCurrentState, NO_ERROR, 0);
}
//-------------------------------------- T[rX󋵂ʒm
BOOL ReportService(DWORD status, DWORD errorcode, DWORD wait)
{
	static DWORD CheckPoint = 1;
	BOOL result;

	if (status == SERVICE_START_PENDING){
		SStatus.dwControlsAccepted = 0;
	}else{
		SStatus.dwControlsAccepted =
								SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_SHUTDOWN;
	}

	SStatus.dwCurrentState =	status;
	SStatus.dwWin32ExitCode =	errorcode;
	SStatus.dwWaitHint =		wait;

	if ( (status == SERVICE_RUNNING) || (status == SERVICE_STOPPED) ){
		SStatus.dwCheckPoint = 0;
	}else{
		SStatus.dwCheckPoint = CheckPoint++;
	}
	if ( !(result = SetServiceStatus(hSStatus, &SStatus)) ){
		DebugLog("SetServiceStatus error", NULL);
	}
	return result;
}
//-------------------------------------- T[rXo^
int InstallService(void)
{
	SC_HANDLE   hService;
	SC_HANDLE   hSCManager;
	TCHAR path[0x200];
	int result;

	if ( !GetModuleFileName(NULL, path, sizeof(path)) ){
		Print(APPNAME " : path error\n");
		return EXIT_FAILURE;
	}

	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if ( hSCManager == NULL ){
		Print(APPNAME " : SCManager failed.\n");
		return EXIT_FAILURE;
	}

	hService = CreateService(hSCManager, T(APPNAME), T(APPNAME),
			SERVICE_ALL_ACCESS,
#if USEDESKTOP
			SERVICE_WIN32_OWN_PROCESS | SERVICE_INTERACTIVE_PROCESS,
#else
			SERVICE_WIN32_OWN_PROCESS,
#endif
			STARTTYPE, SERVICE_ERROR_NORMAL,
			path, NULL, NULL, NULL, NULL, NULL);
	if ( hService != NULL ){
		Print(APPNAME " : installed.\n");
#if ISTART
		StartService(hService, 0, NULL);
#endif
		CloseServiceHandle(hService);
		result = EXIT_SUCCESS;
	}else{
		Print(APPNAME " : install failed.\n");
		result = EXIT_FAILURE;
	}
	CloseServiceHandle(hSCManager);
	return result;
}
//-------------------------------------- T[rX폜
int RemoveService(void)
{
	SC_HANDLE hService;
	SC_HANDLE hSCManager;
	int result;

	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if ( hSCManager == NULL ){
		Print(APPNAME " : SCManager failed.\n");
		return EXIT_FAILURE;
	}
	hService = OpenService(hSCManager, T(APPNAME), SERVICE_ALL_ACCESS);
	if ( hService != NULL ){
		if ( ControlService( hService, SERVICE_CONTROL_STOP, &SStatus)){
										// ÑT[rX~̂҂
			Print("Stopping " APPNAME ".");
			Sleep(100);
			while( QueryServiceStatus(hService, &SStatus) ){
				if ( SStatus.dwCurrentState != SERVICE_STOP_PENDING ) break;
				Print(".");
				Sleep(1000);
			}
			if ( SStatus.dwCurrentState == SERVICE_STOPPED ){
				Print("\n" APPNAME " stopped.\n");
			}else{
				Print("\nfailed to stop.\n");
			}
		}
										// 폜
		if ( DeleteService(hService) ){
			Print(APPNAME " : removed.\n");
		}else{
			Print(APPNAME " delete failed.\n");
		}
		CloseServiceHandle(hService);
		result = EXIT_SUCCESS;
	}else{
		Print(APPNAME " : remode failed.\n");
		result = EXIT_FAILURE;
	}
	CloseServiceHandle(hSCManager);
	return result;
}
/*-----------------------------------------------------------------------------
	R\[ps\
-----------------------------------------------------------------------------*/
void USEFASTCALL Print(const char *str)
{
	DWORD size;

	WriteFile(GetStdHandle(STD_OUTPUT_HANDLE), str, (DWORD)strlen(str), &size, NULL);
}

/*-------------------------------------
	s(\0,\a,\d)H

RET:	==0 :EOL	!=0 :Code
--------------------------------------*/
UTCHAR USEFASTCALL IsEOL(TCHAR **str)
{
	UTCHAR code;

	code = **str;
	if ( code == 0 ) return 0;
	if ( code == 0xd ){
		if ( *(*str + 1) == 0x0a ) (*str)++;
		return 0;
	}
	if ( code == 0xa ){
		if ( *(*str + 1) == 0x0d ) (*str)++;
		return 0;
	}
	return code;
}
/*-------------------------------------
	(space, tabjXLbv

RET:	==0 :EOL	!=0 :Code
--------------------------------------*/
TCHAR USEFASTCALL SkipSpace(TCHAR **str)
{
	UTCHAR code;

	for (;;){
		code = IsEOL(str);
		if ( (code != ' ') && (code != '\t') ) break;
		(*str)++;
	}
	return code;
}

/*-------------------------------------
	̃p[^𒊏oB
	擪Ɩ̋󔒂͏

RET:	擪̕(Ȃ 0)
-------------------------------------*/
UTCHAR GetLineParam(TCHAR **str, TCHAR *param)
{
	UTCHAR code, bottom;
	TCHAR *src, *dst;

	src = *str;
	dst = param;
	bottom = SkipSpace(&src);
	if ( bottom == '\0' ){
		*str = src;
		return 0;
	}
	src++;
	if ( bottom == '\"' ){
		bottom = *src;
		while( 0 != (code = IsEOL(&src)) ){
			src++;
			if ( (code == '\"') && (*src <= ' ') ) break;
			*dst++ = code;
		}
	}else{
		*dst++ = bottom;
		while( 0 != (code = IsEOL(&src)) ){
			src++;
			if (code <= ' ') break;
			*dst++ = code;
		}
	}
	*dst = '\0';
	*str = src;
	return bottom;
}

#if DEBUG
BOOL DebugLog(const char *mesA, const WCHAR *mesW)
{
	char buf[0x400];
	DWORD size;
	SYSTEMTIME ltime;
	HANDLE hFile;

	GetModuleFileNameA(NULL, buf, sizeof(buf));
	strcpy(strrchr(buf, '.'), ".LOG");
												// log J -----------------
	hFile = CreateFileA(buf, GENERIC_WRITE, FILE_SHARE_READ, NULL,
			OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if ( hFile == INVALID_HANDLE_VALUE ) return FALSE;
												// Ɉړ -----------------
	size = 0;
	SetFilePointer(hFile, 0, (PLONG)&size, FILE_END);
												// o -----------------
	GetLocalTime(&ltime);
	size = wsprintfA(buf, "%4d-%02d-%02d %02d:%02d:%02d\t",
			ltime.wYear, ltime.wMonth, ltime.wDay,
			ltime.wHour, ltime.wMinute, ltime.wSecond);
	WriteFile(hFile, buf, size, &size, NULL);
												// eo -----------------
	if ( mesA != NULL ) WriteFile(hFile, mesA, strlen(mesA), &size, NULL);
	if ( mesW != NULL ){
		UnicodeToAnsi(mesW, buf, sizeof(buf));
		WriteFile(hFile, buf, strlen(buf), &size, NULL);
	}
	WriteFile(hFile, "\r\n", 2, &size, NULL);
	CloseHandle(hFile);
	return TRUE;
}
#endif
