/*-----------------------------------------------------------------------------
	syslogd for ClockPod	Rel.1.3					Copyright (c) TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <winsock.h>
#include <string.h>

#include "TOROWIN.H"
#include "TTHEAP.H"
#include "TCFG.H"
#pragma hdrstop

#define MailSlotName	"\\mailslot\\CPODslot"
//-----------------------------------------------------------------------------
// 풓n --------------------------
SOCKET InitSocket(void);
void LoadCfg(ThSTRUCT *cfgstr);

// 풓n ----------------------------
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow);
BOOL WriteLog(char *mes);
void SendCheck(ThSTRUCT *cfgstr, char *log);
void SendPodSlot(char *message);

//=============================================================================
/*-----------------------------------------------------------------------------
	syslog port JÃ\PbgԂ
-----------------------------------------------------------------------------*/
SOCKET InitSocket(void)
{
	SOCKET sock = INVALID_SOCKET;
	WSADATA wsad;

	for (;;){
		SOCKADDR_IN addr;
										//ver1.1v ------------------------
		if ( WSAStartup(0x101, &wsad) ) break;
										// \Pbg̃I[v
		if ( INVALID_SOCKET ==
				(sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) ){
			break;
		}
		addr.sin_family = AF_INET;		// TCP/IPI
		addr.sin_port = htons(514);	//|[g̎w
		addr.sin_addr.s_addr = INADDR_ANY;
										//ڑ
		if ( bind(sock, (const SOCKADDR*)&addr, sizeof(addr)) ){
			closesocket(sock);
			sock = INVALID_SOCKET;
		}
		break;
	}
	if ( INVALID_SOCKET == sock ) WSACleanup();
	return sock;
}
/*-----------------------------------------------------------------------------
	syslogd.cfg JA`e擾
-----------------------------------------------------------------------------*/
void LoadCfg(ThSTRUCT *cfgstr)
{
	DWORD offset = 0;
	char buf[0x1000];
	char *p;
	CFG cfg;
#ifdef UNICODE
	WCHAR bufW[MAX_PATH];
	#define FILENAME bufW
#else
	#define FILENAME buf
#endif
	ThInit(cfgstr);
	GetModuleFileName(NULL, FILENAME, TSIZEOF(FILENAME));
	tstrcpy(tstrrchr(FILENAME, '\\') + 1, T("SYSLOGD.CFG"));
	if ( CFGOpen(&cfg, FILENAME) ){
		while ( CFGGetLine(&cfg, &offset, buf) ){
			p = strchr(buf, '=');
			if ( p != NULL ){
														// L[[h𒊏o
				SkipSpaceB(buf, p - 1);
				p++;

				ThAddString(cfgstr, buf);				// L[[h
				ThAddString(cfgstr, CFGFixParam(p, &p));	// Me
			}
		}
		CFGClose(&cfg);
	}
	ThAddString(cfgstr, "");
}
// 풓n ----------------------------
/*-----------------------------------------------------------------------------
	C[v
-----------------------------------------------------------------------------*/
#pragma argsused
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	SOCKET sock;
	ThSTRUCT cfgstr;
										//  -----------------------------
	if ( 0 == (sock = InitSocket()) ){
		WriteLog("<0> Syslog socket open error");
		return EXIT_FAILURE;
	}
	LoadCfg(&cfgstr);
	WriteLog("<1>Syslog open");
										// C -----------------------------
	for (;;){
		int n;
		char buf[0x1000];

		n = (DWORD)recv(sock, buf, sizeof(buf) - 2, 0);
		if ( n == 0 ) continue;
		if ( n == SOCKET_ERROR ) break;
		buf[n] = 0;
		if ( WriteLog(buf) == FALSE ) break;
		SendCheck(&cfgstr, buf);
	}
										// n -----------------------------
	WriteLog("<1>Syslog close");
//	ThFree(&cfgstr);	// system heap gpĂ邽߁A
	closesocket(sock);
	WSACleanup();
	return EXIT_SUCCESS;
}
/*-----------------------------------------------------------------------------
	Oɏo͂s
-----------------------------------------------------------------------------*/
BOOL WriteLog(char *mes)
{
	char buf[MAX_PATH];
	DWORD size;
	SYSTEMTIME ltime;
	HANDLE hFile;
#ifdef UNICODE
	WCHAR bufW[MAX_PATH];
	#define FILENAME bufW
#else
	#define FILENAME buf
#endif
												// log filename 쐬 --------
	GetModuleFileName(NULL, FILENAME, TSIZEOF(FILENAME));
	tstrcpy(tstrrchr(FILENAME, '\\') + 1, T("SYSLOGD.LOG"));
												// log J -----------------
	hFile = CreateFile(FILENAME, GENERIC_WRITE,
			FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if ( hFile == INVALID_HANDLE_VALUE ) return FALSE;
												// Ɉړ -----------------
	size = 0;
	SetFilePointer(hFile, 0, (PLONG)&size, FILE_END);
												// o -----------------
	GetLocalTime(&ltime);
	size = wsprintfA(buf, "%4d-%02d-%02d %2d:%02d:%02d\t",
			ltime.wYear, ltime.wMonth, ltime.wDay,
			ltime.wHour, ltime.wMinute, ltime.wSecond);
	WriteFile(hFile, buf, size, &size, NULL);
												// eo -----------------
	WriteFile(hFile, mes, (DWORD)strlen(mes), &size, NULL);
	WriteFile(hFile, "\r\n", 2, &size, NULL);
	CloseHandle(hFile);
	return TRUE;
}
/*-----------------------------------------------------------------------------
	`ẽL[[h܂ރbZ[W΂ ClockPod ֑M
-----------------------------------------------------------------------------*/
void SendCheck(ThSTRUCT *cfgstr, char *log)
{
	char *ptr, *send, buf[0x1000];

	ptr = cfgstr->bottom;
	while (*ptr){
		send = ptr + strlen(ptr) + 1;
		if ( strstr(log, ptr) ){
			wsprintfA(buf, send, log);
			SendPodSlot(buf);
		}
		ptr = send + strlen(send) + 1;
	}
}
/*-----------------------------------------------------------------------------
	ClockPod փbZ[W𑗐M
-----------------------------------------------------------------------------*/
void SendPodSlot(char *message)
{
	HANDLE hFile;
	DWORD size;

	hFile = CreateFile(T("\\\\*") T(MailSlotName), GENERIC_WRITE,
		FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if ( hFile != INVALID_HANDLE_VALUE ){
		WriteFile(hFile, message, (DWORD)strlen(message) + 1, &size, NULL);
		CloseHandle(hFile);
	}
}
