/*-----------------------------------------------------------------------------
	Stack Heap Functions						Rel.2005/06	(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include "TOROWIN.H"
#include "THEAP.H"

HANDLE localheap = NULL;

//-----------------------------------------------------------------------------
void ThInit(ThSTRUCT *TH)
{
	TH->bottom = NULL;
	if ( localheap == NULL ) localheap = GetProcessHeap();
}
//-----------------------------------------------------------------------------
BOOL ThFree(ThSTRUCT *TH)
{
	BOOL result = TRUE;
	char *bottom;

	bottom = TH->bottom;
	if ( bottom != NULL ){
		TH->bottom = NULL;
		TH->top = 0;
		TH->size = 0;
		result = HeapFree(localheap, 0, bottom);
	}
	return result;
}

#define ThAllocCheck()								\
	if ( TH->bottom == NULL ){						\
		TH->bottom = HeapAlloc(localheap, 0, ThSTEP);	\
		if ( TH->bottom == NULL ) return INVALID_VALUE(size_t); \
		TH->top = 0;								\
		TH->size = ThSTEP;							\
	}

#define ThSizecheck(CHECKSIZE)						\
	while ( (TH->top + (CHECKSIZE)) > TH->size ){	\
		char *p;									\
		size_t nextsize;							\
													\
		nextsize = TH->size + ThNextAllocSizeM(TH->size);\
		p = HeapReAlloc(localheap, 0, TH->bottom, nextsize);\
		if (p == NULL) return FALSE;				\
		TH->bottom = (void *)p;						\
		TH->size = nextsize;						\
	}

//-----------------------------------------------------------------------------
size_t ThAppend(ThSTRUCT *TH, const void *data, size_t size)
{
	size_t offset;

	ThAllocCheck();
	ThSizecheck(size);
	offset = TH->top;
	memcpy(TH->bottom + offset, data, size);
	TH->top += size;
	return offset;
}
//-----------------------------------------------------------------------------
size_t ThAddString(ThSTRUCT *TH, const TCHAR *data)
{
	size_t size, offset;

	ThAllocCheck();
	size = TSTRSIZE(data);
	ThSizecheck(size + 1);
	offset = TH->top;
	memcpy(TH->bottom + offset, data, size);
	TH->top += size;
	*(TCHAR *)ThLast(TH) = '\0'; //\0Ƃ͕ʂ̕یp
	return offset;
}
//-----------------------------------------------------------------------------
size_t ThCatString(ThSTRUCT *TH, const TCHAR *data)
{
	size_t size, offset;

	ThAllocCheck();
	size = TSTRSIZE(data);
	ThSizecheck(size);
										// ۑ
	offset = TH->top;
	memcpy(TH->bottom + TH->top, data, size);
	TH->top += size - TSTROFF(1);
	return offset;
}
